*------------------------------*
*                              *
*       Flight Simulator       *
*                              *
*  Simulador de voo adaptado   *
*  para deficientes visuais    *
*                              *
*  Autor: Lucas Alexandre      *
*  Em Abril/2014               *
*                              *
*------------------------------*

* Funes de Debug:

seja $debug 0
seja $emestol 0

* Variveis:

* Direo padro do curso da aeronave

seja $direcao "w"

* Mensagens

seja $pilig "Piloto Automtico est ligado."

* Abre WinSock

internet inicia

* Aspas

seja $aspas """

* Avisos ainda no emitidos

seja $wcomb 0
seja $wmtdir 0
seja $wmtesq 0
seja $wveloc 0
seja $waltit 0
seja $fezescala 0

* Dados de voo

seja $pilotoautomatico 0
seja l 0
seja $left 0
seja $right 0
seja $alt 0
seja $tripulantes 0
seja $passageiros 0
seja $subiu 0
seja $flaps 1
seja $fezcontato 0
seja $count 1

* Velocidade inicial no definida. Caso a varivel no receba
* um valor, a aeronave ir entrar em estado de Estol.

seja $velocidade 269

* Online ou no

seja $online 0
seja $copcontrolando 0

* Soquetes de participantes online

seja $3 0
seja $4 0
seja $5 0
seja $6 0
seja $7 0
seja $8 0
seja $9 0

* Tela Inicial

@main
*chama @titulopadrao
seja $emestol 0
seja $velocidade 269
seja $alt 0
seja $aeronave ""
mci m "stop airport"
tela limpa
chama @logo
fala "flight simulator"
chama @veconfig

* Funo para exibir logo do Flight Simulator

@logo
fundo 1
escreve mudo "                      "
escreve mudo "   Flight Simulator   "
escreve mudo "                      "
fundo 0
retorna

* Menu de opes

@opc
mci m "play sons\FS\intro_airship.wav"
mci m "Open sons\FS\intro.mp3 alias intro"
se $intro = 1 mci m "play intro repeat"
escreve ""
escreve "Menu principal"
escreve ""
menu cria 1 7 80 15
menu adiciona "Iniciar voo"
menu adiciona "Voo online"
menu adiciona "Crditos"
menu adiciona "Configuraes"
menu adiciona "Informaes registradas pelo Flight Simulator"
menu executa n l t
menu termina
escreve ""
tela limpa
se l = "#27"
desvia @sairdofs
seno
se n = "1"
seja $funcao "piloto"
soma $tripulantes 1
desvia @main2
seno 
se n = "2"
seja $online 1
chama @seleconline
desvia @main2
seno
se t = "Crditos"
desvia @crd
seno
se t = "Configuraes"
desvia @cfg
seno
se n = 5
desvia @infojogo
seno
se n = 7
desvia @sairdofs
seno
toca "sons\FS\menu_error.wav" &
escreve "Erro na seleo."
tela limpa
desvia @main
      
* Exibe crditos do Flight Simulator

@crd
chama @logo
abre #3 "Crditos.txt"
repete $leitura 26
l #3 $linha
escreve $linha
fim repete
fecha #3
tela limpa
desvia @main
      

* Sair do Flight Simulator

@sairdofs
termina mudo

* D informaes registradas do jogo ao usurio

@infojogo
tela limpa
escreve ""
escreve "Informaes registradas pelo Flight Simulator"
escreve ""
escreve "Nome do comandante: "$nome""
escreve "Total de passageiros conduzidos com xito a seus destinos: "$contpass""
seja x $tempo
se x > 7200
divide x 60
divide x 60
concatena x " horas"
desvia @infojogo2
seno
se x > 3600
seja x "Uma hora"
desvia @infojogo2
seno
se x = 3600
seja x "1 hora"
desvia @infojogo2
seno
se x > 120
divide x 60
concatena x " minutos"
desvia @infojogo2
seno
@infojogo2
escreve "Tempo total aproximado de voo abordo: "x""
tela limpa
desvia @main

* Configuraes

@cfg
tela limpa
escreve ""
escreve "Configuraes do Flight Simulator"
escreve ""
menu cria 1 5 90 9
menu adiciona "Alterar nome do comandante"
menu adiciona "Zerar contadores do jogo"
menu adiciona "Msica de introduo"
menu adiciona "Voltar"
menu executa n l t
menu termina
se l = "#27" desvia @main
se n = "1" desvia @alterarcomandante
se n = "2" desvia @zerarcontadores
se n = "3" desvia @cfgmi
se n = "4" desvia @main

* Configura msica de introduo

@cfgmi
se $intro = 1
seja $intro 0
mci m "close intro"
fecha #2
remove "Flight Simulator.cfg" &
abre #2 "Flight Simulator.cfg" &
escreve #2 "[Flight Simulator]
escreve #2 "comandante="$nome""
escreve #2 "intro=0"
escreve #2 ""
escreve #2 "[contadores]"
escreve #2 "passageiros="$contpass""
escreve #2 "tempo="$tempo""
fecha #2
tela limpa
escreve ""
escreve "Msica de introduo desativada"
tela limpa
desvia @cfg
seno
se $intro = 0
seja $intro 1
mci m "Open Sons\FS\intro.mp3 alias intro"
mci m "play intro repeat"
fecha #2
remove "Flight Simulator.cfg" &
abre #2 "Flight Simulator.cfg" &
escreve #2 "[Flight Simulator]
escreve #2 "comandante="$nome""
escreve #2 "intro=1"
escreve #2 ""
escreve #2 "[contadores]"
escreve #2 "passageiros="$contpass""
escreve #2 "tempo="$tempo""
fecha #2
tela limpa
escreve ""
escreve "Msica de introduo ativada"
tela limpa
desvia @cfg

* Altera nome do comandante

@alterarcomandante
tela limpa
escreve ""
escreve "Alterar nome do comandante"
escreve ""
escreve "Edite o nome do comandante: "&
l edita $nome
busca a "*.cfg"
abre #2 a
l #2 l
l #2 l
l #2 $intro
l #2 l
l #2 l
l #2 $contpass
l #2 $tempo
substitui $tempo "tempo=" ""
substitui $contpass "passageiros=" ""
substitui $intro "intro=" ""
fecha #2
remove a &
abre #2 a &
escreve #2 "[Flight Simulator]"
escreve #2 "comandante="$nome""
escreve #2 "intro="$intro""
escreve #2 ""
escreve #2 "[contadores]"
escreve #2 "passageiros="$contpass""
escreve #2 "tempo="$tempo""
fecha #2
tela limpa
escreve ""
escreve "Configuraes foram salvas."
tela limpa
desvia @cfg

* Zera contadores do jogo (passageiros transportados e horas de voo)

@zerarcontadores
escreve ""
escreve "Zerar contadores do jogo"
escreve ""
escreve "Voc deseja zerar todos os contadores do jogo?"
escreve ""     
escreve "Estado atual dos contadores:"
escreve ""
abre #2 "Flight Simulator.cfg"
l #1 l
l #1 l
l #1 l
l #1 l
l #1 l
l #1 $contpass
l #1 $tempo
escreve "Passageiros transportados com xito a seus destinos: "$contpass""
escreve "Horas de voo efetuadas neste simulador: "$tempo""
fecha #2
escreve ""
escreve "Deseja zerar estes contadores? "&
l mudo z &
se z = "s" desvia @zerarcontadores2
se z = "n" desvia @cfg

@zerarcontadores2
remove "Flight Simulator.cfg" &
abre #2 "Flight Simulator.cfg" &
escreve #2 "[Flight Simulator]"
escreve #2 "comandante="$nome""
escreve #2 ""
escreve #2 "[contadores]"
escreve #2 "passageiros="$contpass""
escreve #2 "tempo="$tempo""
fecha #2
tela limpa
escreve ""
escreve "Configuraes foram salvas."
tela limpa
desvia @cfg

* Seleciona funo do jogador online

@seleconline
tela limpa
escreve ""
escreve "Selecione a funo do seu jogador online: "
escreve ""
menu cria 1 4 40 10
menu adiciona "Piloto"
menu adiciona "Copiloto"
menu adiciona "Passageiro"
menu executa n $l t
menu termina
se $l = "#27"
tela limpa
desvia @main
seno
se n = 1
seja $funcao "piloto"
soma $tripulantes 1
desvia @main2
seno
se n = 2
seja $funcao "copiloto"
desvia @conectacop
seno
se n = 3
seja $funcao "passageiro"
desvia @embarque

* Embarque de um passageiro fora do jogo

@embarque
mci m "Open sons\ambientes\airport.mp3 alias airport"
mci m "play airport repeat"
tela limpa
escreve ""
escreve "Embarque de passageiro"
escreve ""
escreve "Informe o endereo da mquina do voo: "&
l i
se i = "" desvia @main
escreve "Informe a porta da mquina onde o voo est: "&
l p
se p = "" desvia @main
conecta #3 i p
escreve "Conexo realizada"
escreve "Informe seu nome: "&
l n
escreve #3 n
desvia @painelpassageiro

* Painel de controle do passageiro no Aeroporto

@painelpassageiro
tela limpa
observa teclado t
observa #3 m
se t <> 0 desvia @painelpasscmd
se m <> 0 desvia @painelpassmsgsrv
desvia @painelpassageiro

@painelpassmsgsrv
l #3 $mensagem
se $mensagem *=* "[MSG]" escreve $mensagem
se $mensagem *=* "[EMBARCOU]" desvia @avisaembarcou2
se $mensagem *=* "[FS]decolando" desvia @decolagemdopassageiro
desvia @painelpassageiro

* Recebe mensagem de udio

@recebeaudio
l #3 l
se l = "-AUDIO" desvia @recebeaudio2
escreve #1 l
desvia @recebeaudio

@recebeaudio2
fecha #1
decodarqbase64 "!MSGAENVIAR.mp3" "!MSGAOUVIR.mp3"
toca "!MSGAOUVIR.mp3"
remove "!MSGAOUVIR.mp3" &
remove "!MSGAENVIAR.mp3" &
desvia @ctrlpass

* Avisa aos passageiros quem embarcou (entrega resultado)

@avisaembarcou2
substitui $mensagem "[EMBARCOU] " ""
escreve $mensagem
se $funcao = "copiloto" desvia @painelaeroportocop
desvia @painelpassageiro

@painelpasscmd
l c &
se c = "m" desvia @painelpassmsgpass
desvia @painelpassageiro

@painelpassmsgpass
escreve "Escreva sua mensagem:"
l $mensagem
se $mensagem = ""
escreve "Desistiu"
desvia @painelpassageiro
seno
escreve #3 "[MSGPASS] "$mensagem"
desvia @painelpassageiro

* Decolagem do passageiro

@decolagemdopassageiro
l #3 $passageiros
l #3 $voo
l #3 d
l #3 $escala
l #3 t
escreve ""
escreve "Informaes do seu voo: "
escreve ""
escreve "Nome do voo: "$voo""
escreve "N de passageiros: "$passageiros""
escreve "Destino: "d""
se $escala <> "" escreve "Escala: "$escala""
escreve "Tempo do voo: "t""
desvia @decolagem
      
* Embarque do copiloto

@conectacop
tela limpa
escreve ""
escreve "Embarque de copiloto"
escreve ""
escreve "Informe o endereo do servidor do voo: "&
l i
escreve "Informe a porta para conexo: "&
l p
conecta #3 i p
escreve #3 "copiloto"
escreve "Conexo realizada"
escreve "Informe seu nome: "&
l n
escreve #3 n
desvia @painelaeroportocop

* Painel de controle do copiloto no aeroporto

@painelaeroportocop
observa teclado t
observa #3 m
se t <> 0 l c &
se m <> 0 desvia @painelaeroportocop2
desvia @painelaeroportocop

* Processa mensagens no aeroporto (copiloto)

@painelaeroportocop2
l #3 $mensagem
se $mensagem = "[FS]decolando" desvia @predecolcop
se $mensagem = "[FS]EMBARCOU"  desvia @avisaembarcou2
desvia @painelaeroportocop
      
* Seleo de aeronave

@main2
escreve ""
escreve "Selecione uma aeronave para sua misso abaixo: "
escreve ""
menu cria 1 5 130 13
menu adiciona "Airbus A380-800"
menu adiciona "Boeing 737-200"
menu adiciona "Airbus A330-200"
menu adiciona "Boeing 777-200"
menu adiciona "Boeing 737-800"
menu adiciona "McDonell Douglas MD80"
menu executa n $letra t
Menu Termina
se $letra = "#27"
tela limpa
desvia @main
seno
se t = ""
toca "sons\FS\menu_error.wav" &
escreve "Erro na seleo."
tela limpa
desvia @main2
seno
seja $aeronave t
tela limpa
escreve $aeronave
tela limpa
escreve ""
escreve "Por favor selecione uma rota area abaixo: "
escreve ""
menu cria 1 5 90 9
menu adiciona "Aeroporto Internacional Flight Simulator - Aeroporto Internacional de Porto Alegre"
menu adiciona "Aeroporto Internacional de Porto Alegre - Aeroporto Internacional de Guarulhos"
menu adiciona "Aeroporto Internacional de Guarulhos - Aeroporto Internacional do Rio de Janeiro Galeo"
menu adiciona "Aeroporto Internacional do Rio de Janeiro Galeo - Aeroporto Internacional Charles de Gaulle - Pars - Frana"
menu executa n l t
menu termina
tela limpa
se l = "#27" desvia @main2
Se n = "1"  desvia @route1
Se n = "2"  desvia @route2
Se n = "3"  desvia @route3
se n = "4"  desvia @route4

* Rota N 1: Aeroporto Internacional Flight Simulator/Aeroporto
* Internacional de Porto Alegre

@route1
mci m "Open sons\ambientes\airport.mp3 alias aeroporto"
mci m "play aeroporto repeat"
escreve ""
Escreve "Aeroporto Internacional Flight Simulator-Aeroporto"
escreve "Internacional de Porto Alegre"
escreve ""
seja d "Aeroporto Internacional de Porto Alegre"
seja $posiccontatoescala 30200
seja $posiccontato 139000
seja $left 133
seja l 1034
seja $voo "FS"
randomiza
se $online = 1 desvia @embair
se $online = 0 desvia @painelaeroportooffline
@route1b                             
seja $nvoo rand 999
concatena $voo $nvoo
randomiza
se $online = 0 seja $passageiros rand 525
seja $combustivel 60000
seja $altp 19500
seja z "0-152332-253"
seja $destino 152332
seja t "09min44seg"
seja $escala "Aeroporto Internacional de Pelotas"
chama @avisadecolagem
desvia @predecol

* Painel de controle do voo no aeroporto (modo offline)

@painelaeroportooffline
tela limpa
observa teclado t
se t <> 0
l c &
se c = "#13" desvia @voltapararota
se c = "#27" mci m "Stop aeroporto"
se c = "#27" desvia @main
se c = "e" desvia @flapsaeroporto
desvia @painelaeroportooffline
seno
desvia @painelaeroportooffline

@flapsaeroporto
se $flaps = 1
seja $flaps 0
escreve "Posio dos flaps alterada para baixo."
se $online = 0 desvia @painelaeroportooffline
se $online = 1 desvia @painelaeroporto
seno
se $flaps = 0
seja $flaps 1
escreve "Posio dos flaps alterada para cima."
se $online = 0 desvia @painelaeroportooffline
se $online = 1 desvia @painelaeroporto

* Rotina para avisar a decolagem da aeronave aos passageiros

@avisadecolagem
se $3 = 1 escreve #3 "[FS]decolando"
se $3 = 1 escreve #3 $passageiros
se $3 = 1 escreve #3 $voo
se $3 = 1 escreve #3 d
se $3 = 1 escreve #3 $escala
se $3 = 1 escreve #3 t
se $3 = 2 escreve #3 "[FS]decolando"
se $3 = 2 escreve #3 $aeronave
se $3 = 2 escreve #3 $passageiros
se $3 = 2 escreve #3 $voo
se $3 = 2 escreve #3 d
se $3 = 2 escreve #3 $escala
se $3 = 2 escreve #3 t
se $3 = 2 escreve #3 $alt
se $3 = 2 escreve #3 $altp
se $3 = 2 escreve #3 z
se $3 = 2 escreve #3 $tripulantes
se $4 = 1 escreve #4 "[FS]decolando"
se $4 = 1 escreve #4 $passageiros
se $4 = 1 escreve #4 $voo
se $4 = 1 escreve #4 d
se $4 = 1 escreve #4 $escala
se $4 = 1 escreve #4 t
se $5 = 1 escreve #5 "[FS]decolando"
se $5 = 1 escreve #5 $passageiros
se $5 = 1 escreve #5 $voo
se $5 = 1 escreve #5 z
se $5 = 1 escreve #5 $escala
se $5 = 1 escreve #5 t
se $6 = 1 escreve #6 "[FS]decolando"
se $6 = 1 escreve #6 $passageiros
se $6 = 1 escreve #6 $voo
se $6 = 1 escreve #6 d
se $6 = 1 escreve #6 $escala
se $6 = 1 escreve #6 t
se $7 = 1 escreve #7 "[FS]decolando"
se $7 = 1 escreve #7 $passageiros
se $7 = 1 escreve #7 $voo
se $7 = 1 escreve #7 d
se $7 = 1 escreve #7 $escala
se $7 = 1 escreve #7 t
se $8 = 1 escreve #8 "[FS]decolando"
se $8 = 1 escreve #8 $passageiros
se $8 = 1 escreve #8 $voo
se $8 = 1 escreve #8 d
se $8 = 1 escreve #8 $escala
se $8 = 1 escreve #8 t
se $9 = 1 escreve #9 "[FS]decolando"
se $9 = 1 escreve #9 $passageiros
se $9 = 1 escreve #9 $voo
se $9 = 1 escreve #9 d
se $9 = 1 escreve #9 $escala
se $9 = 1 escreve #9 t
retorna

* Rota N 2: Aeroporto Internacional de Porto Alegre/Aeroporto
* Internacional de Guarulhos

@route2
mci m "Open sons\ambientes\airport.mp3 alias aeroporto"
mci m "play aeroporto repeat"
escreve ""
Escreve "Aeroporto Internacional de Porto Alegre-Aeroporto"
escreve "Internacional de Guarulhos"
escreve ""
seja d "Aeroporto Internacional de Guarulhos"
seja $posiccontato 321000
seja l 152332
seja $voo "FS"
seja $fezescala 1
randomiza        
se $online = 1 desvia @embair
se $online = 0 desvia @painelaeroportooffline
@route2b
seja $nvoo rand 999
concatena $voo $nvoo
randomiza
se $online = 0 seja $passageiros rand 525
seja $combustivel 203500
seja $altp 38500
seja z 356227
seja $destino 356227
seja t "13min02seg"
chama @avisadecolagem
desvia @predecol
      
* Rota N 3: Aeroporto Internacional de Guarulhos - Aeroporto
* Internacional do Rio de Janeiro Galeo

@route3
mci m "Open sons\ambientes\airport.mp3 alias aeroporto"
mci m "play aeroporto repeat"
escreve ""
Escreve "Aeroporto Internacional de Guarulhos-Aeroporto"
escreve "Internacional do Rio de Janeiro Galeo"
escreve ""
seja d "Aeroporto Internacional do Rio de Janeiro Galeo"
seja l 356227
seja $fezescala 1
seja $voo "FS"
randomiza
se $online = 1 desvia @embair
se $online = 0 desvia @painelaeroportooffline
@route3b                               
seja $nvoo rand 999
concatena $voo $nvoo
randomiza
se $online = 0 seja $passageiros rand 525
seja $combustivel 230300
seja $altp 39000
seja z 581334
seja $destino 581334
seja t "25min35seg"
chama @avisadecolagem
desvia @predecol
      
* Rota N 4: Aeroporto Internacional do Rio de Janeiro Galeo -
* Aeroporto Internacional Charles de Gaulle - Pars - Frana"

@route4
mci m "Open sons\ambientes\airport.mp3 alias aeroporto"
mci m "play aeroporto repeat"
escreve ""
Escreve "Aeroporto Internacional do Rio de Janeiro Galeo-Aeroporto"
escreve "Internacional Charles de Gaulle - Pars - Frana"
escreve ""
seja d "Aeroporto Internacional Charles de Gaulle"
seja $fezescala 1
seja l 581334    
seja $voo "FS"
randomiza
se $online = 1 desvia @embair
se $online = 0 desvia @painelaeroportooffline
@route4b                                     
seja $nvoo rand 999
concatena $voo $nvoo
randomiza
se $online = 0 seja $passageiros rand 525
seja $combustivel 858000
seja $altp 39000
seja t "0h52min"
seja z 1433254
seja $destino 1433254
chama @avisadecolagem
desvia @predecol

* Pr-decolagem do copiloto

@predecolcop
l #3 $aeronave
l #3 $passageiros
l #3 $voo
l #3 d
l #3 $escala
l #3 t
l #3 $alt
l #3 $altp
l #3 z
l #3 $tripulantes
tela limpa
escreve ""
escreve "Informaes do seu voo"
escreve ""
escreve "Nome do voo: "$voo""
escreve "Nmero de passageiros: "$passageiros""
escreve "Destino: "d""
se $escala <> "" escreve "Escala: "$escala""
escreve "Tempo aproximado de voo: "t""
desvia @decolagem
      
* Pr-decolagem do piloto

@predecol
escreve "Aeronave: "$aeronave""
escreve "Localizao do destino (m): "z" metros ("d")"
escreve "Tempo aproximado do voo: "t""
escreve "Combustvel: "$combustivel" litros"
escreve "Altura em ps: "$altp" ps"
escreve "Passageiros: "$passageiros""
escreve "Tripulantes: "$tripulantes""
se $escala <> "" escreve "Escala: "$escala""
escreve "Descrio: Conduza com segurana "$passageiros" passageiros"
escreve "           para o "d","
escreve "           com escala no "$escala"."
se $3 = 1 escreve $3 $passageiros
se $4 = 1 escreve $4 $passageiros
se $5 = 1 escreve $5 $passageiros
se $6 = 1 escreve $6 $passageiros
se $7 = 1 escreve $7 $passageiros
se $8 = 1 escreve $8 $passageiros
se $9 = 1 escreve $9 $passageiros
desvia @decolagem
      
* Embarque de passageiros

@embair
escreve ""
se $passageiros = 0
escreve "Nenhum passageiro fez check in."
escreve ""
@primeiropass
escreve "Informe uma porta no usada para conectar o primeiro passageiro."
@portaprimeiropass
l p
se p = "" desvia @portaprimeiropass
serve #3 p
seja $3 1
enquanto no m <> 0
observa #3 m
fim enquanto
l #3 $nome3
*  um copiloto?
se $nome3 = "copiloto"
seja $3 2
chama @esperanomecp
escreve "Copiloto "$nome3" embarcou no voo."
soma $tripulantes 1
desvia @maisembair
seno
*  um passageiro...
seja $ass3 "A2"
seja $3 1
escreve "Passageiro "$nome3" embarcou no voo - Assento "$ass3""
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome3
concatena $embarcou " embarcou no voo - Assento "
concatena $embarcou $ass3
soma $passageiros 1
chama @avisaembarcou
desvia @painelaeroporto

* Painel do comandante no aeroporto

@painelaeroporto
observa teclado t
se t <> 0 desvia @painelaeroporto2
observa #3 m
se m <> 0
l #3 $msg
desvia @aeroportoprocmsgpass
seno
observa #4 m
se m <> 0
l #4 $msg
desvia @aeroportoprocmsgpass
seno
observa #5 m
se m <> 0
l #5 $msg
desvia @aeroportoprocmsgpass
seno
observa #6 m
se m <> 0
l #6 $msg
desvia @aeroportoprocmsgpass
seno
observa #7 m
se m <> 0
l #7 $msg
desvia @aeroportoprocmsgpass
seno
observa #8 m
se m <> 0
l #7 $msg
desvia @aeroportoprocmsgpass
seno
observa #9 m
se m <> 0
l #9 $msg
desvia @aeroportoprocmsgpass
seno
desvia @painelaeroporto

@painelaeroporto2
l c &
se c = "c" desvia @maisembairescala
se c = "#13" desvia @voltapararota
se c = "e" desvia @flapsaeroporto
se c = "n" desvia @aeroportomsgcop
se c = "m" desvia @aeroportomsgpass
desvia @painelaeroporto

* Envia mensagem do aeroporto aos passageiros

@aeroportomsgpass
escreve "Escreva sua mensagem: "&
l $mensagem
se $3 = 1 escreve #3 "[MSGPILOTO] Comandante "$nome" disse: "$mensagem""
se $4 = 1 escreve #4 "[MSGPILOTO] Comandante "$nome" disse: "$mensagem""
se $5 = 1 escreve #5 "[MSGPILOTO] Comandante "$nome" disse: "$mensagem""
se $6 = 1 escreve #6 "[MSGPILOTO] Comandante "$nome" disse: "$mensagem""
se $7 = 1 escreve #7 "[MSGPILOTO] Comandante "$nome" disse: "$mensagem""
se $8 = 1 escreve #8 "[MSGPILOTO] Comandante "$nome" disse: "$mensagem""
se $9 = 1 escreve #9 "[MSGPILOTO] Comandante "$nome" disse: "$mensagem""
desvia @painelaeroporto

@aeroportoprocmsgpass
se $msg *=* "[MSGPASS]"
substitui $msg "[MSGPASS] " "
se $3 = 1 escreve #3 "[MSG] Passageiro "$nome3" disse: "$msg""
se $4 = 1 escreve #4 "[MSG] Passageiro "$nome4" disse: "$msg""
se $5 = 1 escreve #5 "[MSG] Passageiro "$nome5" disse: "$msg""
se $6 = 1 escreve #6 "[MSG] Passageiro "$nome6" disse: "$msg""
se $7 = 1 escreve #7 "[MSG] Passageiro "$nome7" disse: "$msg""
se $8 = 1 escreve #8 "[MSG] Passageiro "$nome8" disse: "$msg""
se $9 = 1 escreve #9 "[MSG] Passageiro "$nome9" disse: "$msg""
desvia @painelaeroporto
seno
se $msg *=* "[MSGCOP]"
substitui $msg "[MSGCOP] " ""
escreve "[MSG] Copiloto "$nome3" disse: "$msg""
desvia @painelaeroporto
seno
desvia @painelaeroporto

* Espera nome do copiloto

@esperanomecp
enquanto no m <> 0
observa #3 m
fim enquanto
l #3 $nome3
retorna

* Permite o embarque de mais passageiros

@maisembair
escreve ""
se $passageiros = 0
escreve ""$passageiros" passageiros e "$tripulantes" tripulantes"
escreve "So necessrios um ou mais passageiros para o voo."
desvia @painelaeroporto
seno
desvia @painelaeroporto

* Volta para onde foi chamado

@voltapararota
se d = "Aeroporto Internacional de Porto Alegre" desvia @route1b
se d = "Aeroporto Internacional de Guarulhos" desvia @route2b
se d = "Aeroporto Internacional do Rio de Janeiro Galeo" desvia @route3b
se d = "Aeroporto Internacional Charles de Gaulle" desvia @route4b

* Conexo dos demais passageiros

@maisembair2
se $passageiros = 9 desvia @excedeulimite
escreve ""
escreve "Informe uma porta livre para conectar o passageiro: "&
@portademaispassageiros
l p
se p = "" desvia @portademaispassageiros
se $4 = 0
serve #4 p
seja $4 1
desvia @continuacontato
seno
se $5 = 0
serve #5 p
seja $5 1
desvia @continuacontato
seno 
se $6 = 0
serve #6 p
seja $6 1
desvia @continuacontato
seno
se $7 = 0
serve #7 p
seja $7 1
desvia @continuacontato
seno
se $8 = 0
serve #8 p
seja $8 1
desvia @continuacontato
seno
se $9 = 0
serve #9 p
seja $9 1
desvia @continuacontato

* Limite de passageiros foi excedido

@excedeulimite
escreve ""
escreve "Nmero de passageiros e tripulantes excedido."
escreve ""
escreve "Por favor, pressione qualquer tecla  para iniciar a decolagem da aeronave."
l r &
tela limpa
desvia @voltapararota

* Prossegue contato com o passageiro aps verificaes

@continuacontato
@loopmais
observa #4 m
se m <> 0
l #4 $nome4
seja $ass4 "A3"
escreve "Passageiro "$nome4" embarcou no voo - Assento "$ass4"""
soma $passageiros 1
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome4
concatena $embarcou " embarcou no voo - Assento "
concatena $embarcou $ass4
chama @avisaembarcou
se $fezescala = 1 desvia @escala3
desvia @maisembair
seno
observa #5 m
se m <> 0
l #5 $nome5
seja $ass5 "A4"
escreve "Passageiro "$nome5" embarcou no voo - Assento "$ass5""
soma $passageiros 1
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome5
concatena $embarcou "embarcou no voo - Assento "
concatena $embarcou $ass5
chama @avisaembarcou
se $fezescala = 1 desvia @escala3
desvia @maisembair
seno
observa #6 m
se m <> 0
l #6 $nome6
soma $passageiros 1
seja $ass6 "A5"
escreve "Passageiro "$nome6" embarcou no voo - Assento "$ass6""
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome6
concatena $embarcou "embarcou no voo - Assento "
concatena $embarcou $ass6
chama @avisaembarcou
se $fezescala = 1 desvia @escala3
desvia @maisembair      
seno
observa #7 m
se m <> 0
l #7 $nome7
seja $ass7 "A6"
escreve "Passageiro "$nome7" embarcou no voo - Assento "$ass7""
soma $passageiros 1
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome7
concatena $embarcou "embarcou no voo - Assento "
concatena $embarcou $ass7
chama @avisaembarcou
se $fezescala = 1 desvia @escala3
desvia @maisembair      
seno
observa #8 m
se m <> 0
l #8 $nome8
seja $ass8 "A7"
escreve "Passageiro "$nome8" embarcou no voo - Assento "$ass8""
soma $passageiros 1
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome8
concatena $embarcou "embarcou no voo - Assento
concatena $embarcou $ass8
chama @avisaembarcou
se $fezescala = 1 desvia @escala3
desvia @maisembair      
seno
observa #9 m
se m <> 0
l #9 $nome9
seja $ass9 "A8"
escreve "Passageiro "$nome9" embarcou no voo - Assento "$ass9""
soma $passageiros 1
seja $embarcou $nome9
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome9
concatena $embarcou "embarcou no voo - Assento "
concatena $embarcou $ass9
chama @avisaembarcou
se $fezescala = 1 desvia @escala3
desvia @maisembair      
seno
desvia @loopmais

* Embarque de mais passageiros (escala)

@maisembairescala
se $passageiros = 9 desvia @excedeulimite
escreve ""
escreve "Informe uma porta livre para conectar o passageiro: "&
@portademaispassageirosescala
l p
se p = "" desvia @portademaispassageirosescala
se $4 = 0
serve #4 p
seja $4 1
desvia @continuacontatoescalaescala
seno          
se $5 = 0
serve #5 p
seja $5 1
desvia @continuacontatoescala
seno          
se $6 = 0
serve #6 p
seja $6 1
desvia @continuacontatoescala
seno          
se $7 = 0
serve #7 p
seja $7 1
desvia @continuacontatoescala
seno          
se $8 = 0
serve #8 p
seja $8 1
desvia @continuacontatoescala
seno
se $9 = 0
serve #9 p
seja $9 1
desvia @continuacontatoescala

* Continua contato de embarque de passageiro (escala)

@continuacontatoescala
@loopmaisescala
observa #4 m
se m <> 0
l #4 $nome4
seja $ass4 "A3"
escreve "Passageiro "$nome4" embarcou no voo - Assento "$ass4"""
soma $passageiros 1
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome4
concatena $embarcou " embarcou no voo - Assento "
concatena $embarcou $ass4
chama @avisaembarcou
desvia @escala3
seno 
observa #5 m
se m <> 0
l #5 $nome5
seja $ass5 "A4"
escreve "Passageiro "$nome5" embarcou no voo - Assento "$ass5""
soma $passageiros 1
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome5
concatena $embarcou "embarcou no voo - Assento "
concatena $embarcou $ass5
chama @avisaembarcou
desvia @escala3
seno 
observa #6 m
se m <> 0
l #6 $nome6
soma $passageiros 1
seja $ass6 "A5"
escreve "Passageiro "$nome6" embarcou no voo - Assento "$ass6""
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome6
concatena $embarcou "embarcou no voo - Assento "
concatena $embarcou $ass6
chama @avisaembarcou
desvia @escala3
seno 
observa #7 m
se m <> 0
l #7 $nome7
seja $ass7 "A6"
escreve "Passageiro "$nome7" embarcou no voo - Assento "$ass7""
soma $passageiros 1
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome7
concatena $embarcou "embarcou no voo - Assento "
concatena $embarcou $ass7
chama @avisaembarcou
desvia @escala3
seno 
observa #8 m
se m <> 0
l #8 $nome8
seja $ass8 "A7"
escreve "Passageiro "$nome8" embarcou no voo - Assento "$ass8""
soma $passageiros 1
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome8
concatena $embarcou "embarcou no voo - Assento
concatena $embarcou $ass8
chama @avisaembarcou
desvia @escala3
seno 
observa #9 m
se m <> 0
l #9 $nome9
seja $ass9 "A8"
escreve "Passageiro "$nome9" embarcou no voo - Assento "$ass9""
soma $passageiros 1
seja $embarcou $nome9
seja $embarcou "[EMBARCOU] Passageiro "
concatena $embarcou $nome9
concatena $embarcou "embarcou no voo - Assento "
concatena $embarcou $ass9
chama @avisaembarcou
desvia @escala3
seno 
desvia @loopmaisescala

* Avisa embarque no aeroporto aos outros passageiros

@avisaembarcou
se $3 = 1 escreve #3 $embarcou
se $2 = 1 escreve #3 $embarcou
se $4 = 1 escreve #4 $embarcou
se $5 = 1 escreve #5 $embarcou
se $6 = 1 escreve #6 $embarcou
se $7 = 1 escreve #7 $embarcou
se $8 = 1 escreve #8 $embarcou
se $9 = 1 escreve #9 $embarcou
retorna

* Procedimento de Decolagem

@decolagem
tela limpa
seja $tempoabordo 0
escreve ""
escreve "  Iniciando decolagem do voo "$voo"..."
escreve ""
escreve "  Ateno todos os passageiros!"
escreve ""
escreve "- Estamos iniciando a decolagem do voo "$voo"."
escreve "- Apertem seus cintos de segurana."
escreve "- Em cerca de "t" chegaro a seus destinos"
escreve "- conduzidos com segurana por nossa tripulao."
escreve " "
se $funcao = "piloto" chama @presskey
escreve ""
escreve "   Iniciando decolagem do voo "$voo""
mci m "close intro"
tela limpa
se $funcao = "piloto"
seja $arquivo "fdr\"
concatena $arquivo $voo
concatena $arquivo ".fdr"
abre #1 $arquivo &
escreve #1 ""
escreve #1 "Dados do voo "$voo""
escreve #1 ""
seja $dia dia
seja $data data
seja $hora hora
copia $dia1 $data 1 2
copia $mes $data 4 5
copia $ano $data 7 10
copia $hora1 $hora 1 5
seja $hora $hora1
substitui $mes "01" "de Janeiro"
substitui $mes "02" "de Fevereiro"
substitui $mes "03" "de Maro"
substitui $mes "04" "de Abril"
substitui $mes "05" "de Maio"
substitui $mes "06" "de Junho"
substitui $mes "07" "de Julho"
substitui $mes "08" "de Agosto"
substitui $mes "09" "de Setembro"
substitui $mes "10" "de Outubro"
substitui $mes "11" "de Novembro"
substitui $mes "12" "de Dezembro"
escreve #1 "Realizado em: "$dia", "$dia1" "$mes" de "$ano" s "$hora" GMT"
escreve #1 "Comandante: "$nome""
se $3 = 2 escreve #1 "Copiloto: "$nome3""
escreve #1 "Passageiros a bordo: "$passageiros""
escreve #1 "Tripulantes: "$tripulantes""
escreve #1 "Destino: "z" ("d")"
chama @local
escreve #1 "Local da decolagem: "l" ("d")"
se $escala <> "" escreve #1 "Escala: "$escala""
seja $horario hora
escreve #1 "Horrio atual: "$horario" GMT"
escreve #1 ""
escreve #1 "Lista de passageiros a bordo do voo "$voo""
escreve #1 ""
se $3 = 1 escreve #1 ""$nome3" (passageiro)"
se $3 = 2 escreve #1 ""$nome3" (copiloto)"
se $4 = 1 escreve #1 ""$nome4" (passageiro)"
se $5 = 1 escreve #1 ""$nome5" (passageiro)"
se $6 = 1 escreve #1 ""$nome6" (passageiro)"
se $7 = 1 escreve #1 ""$nome7" (passageiro)"
se $8 = 1 escreve #1 ""$nome8" (passageiro)"
se $9 = 1 escreve #1 ""$nome9" (passageiro)"
escreve #1 ""
escreve #1 "Dados registrados"
escreve #1 ""
escreve #1 "Data       Hora       Tipo de dado      Valor"
escreve #1 ""
fecha #1
abre #1 $arquivo &
escreve ""
escreve "Aeronave no piloto manual."
escreve ""
escreve "Iniciando subida da aeronave"
escreve ""
escreve ""$alt" ps"
desvia @decolagem2
seno
@decolagem2
mci m "stop airport"
mci m "stop aeroporto"
mci m "Open sons\ambientes\amb.mp3 alias fundo"
mci m "play fundo repeat"
toca "Sons\aeronave\decol.mp3" &
toca "Sons\FS\welcome_passengers.wav" &
espera 26
seja $titulo "Flight Simulator - Voo "
concatena $titulo $voo
concatena $titulo " - "
concatena $titulo $passageiros
concatena $titulo " passageiros"
Titulo $titulo
se $online = 0 desvia @painel
se $online = 1 desvia @trataonline

* Funo para pressionar qualquer tecla para iniciar decolagem

@presskey
escreve "Pressione qualquer tecla para iniciar a decolagem."
l mudo o &
espera 1
retorna

* Tratamento de jogadores online

@trataonline
se $funcao = "passageiro" desvia @ctrlpass
se $funcao = "piloto" desvia @painel
se $funcao = "copiloto" desvia @ctrlcop

* Controle do copiloto no voo

@ctrlcop
observa teclado t
observa #3 m
se t <> 0 desvia @cmdcop
se m <> 0 desvia @menspiloto
desvia @ctrlcop

@menspiloto
l #3 $mensagem
se $mensagem *=* "[MSG"
substitui $mensagem "[MSG] " ""
escreve $mensagem
desvia @ctrlcop
seno
se $mensagem = "[FS]controle1"
seja $controlando 1
desvia @ctrlcop
seno
se $mensagem = "[FS]controle0"
seja $controlando 0
desvia @ctrlpass
      
* Comandos que podem ser realizados pelo copiloto

@cmdcop
l c &
se c = "d" desvia @pedelocal2
se c = "#0#72" desvia @ckmm
desvia @ctrlcop

* Controle manual da aeronave (copiloto)

@ckmm
seja r rand 5
subtrai $velocidade r
seja r rand 9
soma $velocidade r
escreve #3 "+"$velocidade""
enquanto no m <> 0
observa #3 m
fim enquanto
se m *=* "pilig" escreve "Piloto automtico ligado"
se m *=* "+OK" desvia @ctrlcop
desvia @ctrlcop

* Copiloto requisitando local da aeronave

@pedelocal2
escreve #3 "local"
enquanto no m <> 0
observa #3 m
fim enquanto
l #3 $local
escreve $local
desvia @ctrlcop

* Controle do passageiro no voo

@ctrlpass
observa teclado t
se t <> 0 desvia @cmdpass
observa #3 m
se m <> 0 desvia @msgsrv
desvia @ctrlpass 

* Comandos permitidos para os passageiros

@cmdpass
l c &
se c = "m" desvia @msgatodospass
se c = "d" desvia @pedelocal
se c = "1" chama @ouvirmusica
se c = "2" chama @pausamusica
se c = "3" chama @repetemusica
desvia @ctrlpass

* Recebe mensagens do servidor

@msgsrv
l #3 w
se w *=* "[MSG" escreve w
se w *=* "[FS]pousado" desvia @pousopass
se w *=* "[FS]escalando" desvia @passescala
se w *=* "[FS]queda" desvia @caiupass
se w *=* "[FS]quedaagua" desvia @caiupass
se w *=* "[FS]quedaagualagoa" desvia @caiupass
se w *=* "[FS]quedafora" desvia @pfapass
se w *=* "[FS]chovendo"  desvia @chuvapass
se w *=* "[FS]pchovendo" desvia @parachuvapass
se w *=* "[FS]cancelado" desvia @canceladopass
se w = "+AUDIO" abre #1 "!MSGAENVIAR.mp3" &
se w = "+AUDIO" desvia @recebeaudio
desvia @ctrlpass

* Avisa que voo foi cancelado

@canceladopass
tela limpa
escreve "O voo "$voo" foi cancelado."
desvia @main

* Controla som de chuva na cabine os passageiros

@chuvapass
mci m "Open Sons\Ambientes\storm.mp3 alias chuva"
mci m "play chuva repeat"
mci m "play Sons\Ambientes\thunder1.mp3"
desvia @ctrlpass

* Para som de chuva na cabine dos passageiros

@parachuvapass
mci m "close chuva"
desvia @ctrlpass

* Passageiros esperando a escala do voo

@passescala
tela limpa
escreve ""
mci m "stop fundo"
mci m "stop musica"
mci m "stop chuva"
mci m "play airport repeat"
escreve "O voo "$voo" est realizando sua escala no "$escala"."
desvia @passescala2                      

@passescala2
observa teclado t
observa #3 m
se t <> 0 l c &
se m <> 0 l #3 m
se c = "#27" desvia @sairdovooescala
se m = "[SAIU]" desvia @saiuescala
desvia @passescala2

@sairdovooescala
tela limpa
escreve "Deseja sair do voo "$voo"? "&
l $sair mudo &
se $sair = "s"
escreve #3 "[FS]desconec"
toca "Sons\FS\desembarcando.wav" &
escreve "Passageiro "n" saiu do voo"
tela limpa
desvia @main
seno
desvia @passescala2

@saiuescala
substitui m "[SAIU] " ""
toca "Sons\FS\embarcando.wav" &
escreve m
desvia @passescala2

mci m "stop airport"
mci m "play sons\aeronave\decol.mp3"
mci m "play musica repeat"
mci m "play fundo repeat"
escreve ""
escreve "Vo "$voo" partindo da escala no "$escala" em trnsito"
escreve "para "d""
desvia @ctrlpass
seno
desvia @enquantoescala

* Conversa entre passageiros

@msgatodospass
escreve "Escreva sua mensagem: "&
l $msg
escreve #3 "[MSG]: "$msg""
desvia @ctrlpass

* Pede localizao da aeronave ao servidor

@pedelocal
escreve #3 "local"
enquanto no m <> 0
observa #3 m
fim enquanto
l #3 $local
escreve $local
desvia @ctrlpass

* Pouso dos passageiros

@pousopass
imagem
tela limpa
mci m "stop chuva"
mci m "stop fundo"
escreve ""
escreve "O voo "$voo" pousou no "d" com "$passageiros" passageiros."
desvia @main

* Subida da Aeronave

@subida
se $emestol = 1 retorna
se $alt > $altp
seja $alt $altp
seja $subiu 1
escreve ""$alt" ps"
retorna
seno
soma $alt 1500
soma l 222
toca "Sons\Aeronave\vel_up.wav" &
escreve ""$alt" ps"
se $flaps = 1 chama @flapscima
retorna
seno
retorna

* Impede decolagem por flaps posicionados para cima

@flapscima
se $alt > 5000 subtrai $alt 4000
se $alt < 1000 subtrai $alt 2000
se $alt = 3500 subtrai $alt 4000
se $aeronave *=* "Boeing" mci m "Open sons\estol\Boeing\flaps.mp3 alias estol"
se $aeronave *=* "Boeing" mci m "play estol repeat"
fala "ALERTA"
fala "Flaps na posio cima"
se $alt <= 0 desvia @caiu
retorna            

* Painel de controle principal da Aeronave

@painel

* Exibe Aeronave na tela

imagem "Imagens\B737.jpg" 60 0

* Controla tempo abordo da aeronave

chama @tempoabordo

* Controla Panning

chama @panningesquerda
chama @panningdireita

tela limpa

tela @0,10
cor 2
escreve mudo "------------------------------------------------------"
escreve mudo ""
escreve mudo "   "$aeronave"                     Voo "$voo""
escreve mudo ""
escreve mudo ""
escreve mudo "    "$velocidade" m/s     Direo "&
se $direcao = "w" escreve mudo "norte "&
se $direcao = "s" escreve mudo "sul "&
escreve mudo "     "$alt" ps"
escreve mudo ""
seja $horas $tempoabordo
seja $minutos $tempoabordo
divide $horas 3600
divide $minutos 60
se $horas < 10 copia $horas2 $horas 1 1
se $horas < 10 seja $horas "0"
se $horas < 10 concatena $horas $horas2
se $minutos < 10 copia $minutos2 $minutos 1 1
se $minutos < 10 seja $minutos "0"
se $minutos < 10 concatena $minutos $minutos2
escreve mudo "    "$horas":"$minutos"         "&
se $passageiros = 1 escreve mudo "Um passageiro         " &
se $passageiros > 1 escreve mudo ""$passageiros" passageiros   "&
escreve mudo "Flaps para "&
se $flaps = 0 escreve mudo "baixo"
se $flaps = 1 escreve mudo "cima"
escreve mudo ""
escreve mudo "    Alarmes"
escreve mudo ""
escreve mudo "    Estol " &
cor 4
se $emestol = 1 escreve mudo " ! "&
cor 2
escreve mudo "   Pouco combustvel "&
cor 4
se $combustivel < 5000 escreve mudo " ! "&
cor 2
escreve mudo ""
escreve mudo ""
escreve mudo "------------------------------------------------------"
cor 15
tela @2,2

* Verifica mudana de altitude e realiza alteraes

se $mudandodealt = 1 chama @mudandoalt
                           
* Realiza a subida, caso esteja decolando

se $subiu = 0 chama @subida

* Verifica se aeronave poder entrar no estado de Estol

se $velocidade <= 30 chama @pestol
se $velocidade >  30 chama @paraestol

* Gera possvel chuva

randomiza
seja $chovendo rand 330
se $chovendo = 22 chama @controlachuva
se $chovendo = 55 chama @parachuva

* Entrada de Teclado

observa teclado t
se t <> 0 desvia @cmd
                
* Procedimentos padro:

se $pilotoautomatico = 1 chama @km
se $pilotoautomatico = 0 seja r rand 1
se $pilotoautomatico = 0 soma l r
se $pilotoautomatico = 0 seja r rand 1
se $pilotoautomatico = 0 subtrai l r
se $pilotoautomatico = 0 subtrai $combustivel 5

* Avisos

se $combustivel      <= 0 chama @queda
se $combustivel      <= 2000 chama @wmtesq
se $combustivel      <= 4000 chama @wmtdir
se $combustivel      <= 5000 chama @wcomb
se $velocidade       <= 30    chama @wveloc
se $alt              < 8000  chama @waltit

* Verifica e corrige automaticamente altitude

chama @corrigealt

* Verifica se aeronave est em estol, para possibilitar o uso dos
* comandos da aeronave.

se $emestol = 1 chama @emestol

* Verifica se passageiros enviaram algumma coisa

se $online = 1 desvia @veospass

desvia @painel

* Para chuva

@parachuva
se $3 = 1 escreve #3 "[FS]pchovendo"
se $4 = 1 escreve #4 "[FS]pchovendo"
se $5 = 1 escreve #5 "[FS]pchovendo"
se $6 = 1 escreve #6 "[FS]pchovendo"
se $7 = 1 escreve #7 "[FS]pchovendo"
se $8 = 1 escreve #8 "[FS]pchovendo"
se $9 = 1 escreve #9 "[FS]pchovendo"
mci m "close chuva"
seja $chuva 0
retorna

* Rotina para desativar Estol quando a velocidade for maior que 30 m/s
*
* Nota: Esta funo j existe em @pestol, mas s vale para flaps
* para cima.                     
*

@paraestol
seja $emestol 0
mci m "stop estol"
mci m "stop estolii"
mci m "stop estol2"
mci m "stop sons\Alarmes\Boeing\estol1.wav"
retorna

* Controla uma chuva

@controlachuva
se $3 = 1 escreve #3 "[FS]chovendo"
se $4 = 1 escreve #4 "[FS]chovendo"
se $5 = 1 escreve #5 "[FS]chovendo"
se $6 = 1 escreve #6 "[FS]chovendo"
se $7 = 1 escreve #7 "[FS]chovendo"
se $8 = 1 escreve #8 "[FS]chovendo"
se $9 = 1 escreve #9 "[FS]chovendo"
seja $chuva 1        
mci m "Open Sons\Ambientes\storm.mp3 alias chuva"
mci m "play chuva repeat"
toca "Sons\Ambientes\thunder1.mp3" &
retorna

* Checa a possibilidade de um Estol

@pestol
se $aeronave *=* "A380"
seja $emestol 0
toca "Sons\Aeronave\vel_up.wav" &
seja $velocidade 260
retorna
seno
se $flaps = 1
seja $emestol 0
mci m "stop estol"
mci m "stop estol2"
mci m "stop estolii"
retorna
seno
se $flaps = 0
seja $emestol 1
retorna

* Conta tempo de voo do piloto

@tempoabordo
se $pilotoautomatico = 0
espera 1
soma $tempoabordo 1
retorna
seno
soma $tempoabordo 1
retorna

* Monitora mensagens dos passageiros

@veospass
observa #3 m
se m <> 0
seja $mandou "#3"
desvia @veospass2
seno
observa #4 m
se m <> 0
seja $mandou "#4"
desvia @veospass2
seno
observa #5 m
se m <> 0
seja $mandou "#5"
desvia @veospass2
seno
observa #6 m
se m <> 0
seja $mandou "#6"
desvia @veospass2
seno
observa #7 m
se m <> 0
seja $mandou "#7"
desvia @veospass2
seno
observa #8 m
se m <> 0
seja $mandou "#8"
desvia @veospass2
seno
observa #9 m
se m <> 0
seja $mandou "#9"
desvia @veospass2

@veospass2
se $mandou = "#3" l #3 m
se $mandou = "#4" l #4 m
se $mandou = "#5" l #5 m
se $mandou = "#6" l #6 m
se $mandou = "#7" l #7 m
se $mandou = "#8" l #8 m
se $mandou = "#9" l #9 m
fim se
se m *=* "[MSG]" desvia @msgdospass
se m *=* "local" desvia @envialocal
se m =*  "+" desvia @maisveloccopiloto
se m =*  "-" desvia @menosveloccopiloto
desvia @painel

@maisveloccopiloto
se $pilotoautomatico = 1
escreve #3 "pilig"
desvia @painel
seno
soma l m
escreve #3 "+OK"
desvia @painel

@menosveloccopiloto
se $pilotoautomatico = 1
escreve #3 "pilig"
desvia @painel
seno
subtrai l m
escreve #3 "+OK"
desvia @painel

* Verifica e corrige altitude

@corrigealt
se $emestol = 1 retorna
se $alt     > 43500 chama @corrigealtalta
se $alt     < 10000 chama @corrigealtbaixa
retorna

@corrigealtalta
subtrai $alt 2000
se $alt < $altp seja $alt $altp
retorna

@corrigealtbaixa
soma $alt 2000
se $alt > $altp seja $alt $altp
retorna

* Envia localizao da aeronave a um passageiro (resposta do pedido do 
* rtulo @pedelocal

@envialocal
chama @local
se $mandou = "#3" escreve #3 "Localizao: "$left"-"l"-"$right" ("$local")"
se $mandou = "#4" escreve #4 "Localizao: "$left"-"l"-"$right" ("$local")"
se $mandou = "#5" escreve #5 "Localizao: "$left"-"l"-"$right" ("$local")"
se $mandou = "#6" escreve #6 "Localizao: "$left"-"l"-"$right" ("$local")"
se $mandou = "#7" escreve #7 "Localizao: "$left"-"l"-"$right" ("$local")"
se $mandou = "#8" escreve #8 "Localizao: "$left"-"l"-"$right" ("$local")"
se $mandou = "#9" escreve #9 "Localizao: "$left"-"l"-"$right" ("$local")"
desvia @painel              

* Entrega mensagem de um passageiro a todos

@msgdospass
substitui m "[MSG]: " ""

seja $comando "[MSG] Passageiro "
se $mandou = "#3" concatena $comando $nome3
se $mandou = "#4" concatena $comando $nome4
se $mandou = "#5" concatena $comando $nome5
se $mandou = "#6" concatena $comando $nome6
se $mandou = "#7" concatena $comando $nome7
se $mandou = "#8" concatena $comando $nome8
se $mandou = "#9" concatena $comando $nome9
concatena $comando " disse: "
concatena $comando m

* Impede que passageiros confundam outros clientes de passageiros
* enviando comandos do prprio jogo para realizar operaes no jogo
* ou na aeronave

substitui $comando "[FS]queda" ""
substitui $comando "[FS]quedafora" ""
substitui $comando "[FS]pousado" ""

se $3 = 1 escreve #3 $comando
se $4 = 1 escreve #4 $comando
se $5 = 1 escreve #5 $comando
se $6 = 1 escreve #6 $comando
se $7 = 1 escreve #7 $comando
se $8 = 1 escreve #8 $comando
se $9 = 1 escreve #9 $comando
seja $data data
seja $hora hora
substitui $comando "[MSG]" ""
escreve #1 ""$data" "$hora" GMT   Mensagem dos passageiros      "$comando""
desvia @painel

* Comandos do piloto

@cmd
l c &
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT    Comando    "c""
se c = "#0#72" desvia @kmm
se c = "#0#66" chama @hora
se c = "#0#80" desvia @kmmb
se c = "#0#77" desvia @cdir
se c = "#0#75" desvia @cesq
se c = "i" chama @info
se c = "p" desvia @pouso
se c = "o" desvia @cabcop
se c = "e" desvia @ctrlflaps
se c = "l" desvia @listapass
se c = "y" desvia @dir
se c = "s" desvia @sul
se c = "w" desvia @norte
se c = "r" desvia @radarmet
se c = "1" chama @ouvirmusica
se c = "2" chama @pausamusica
se c = "3" chama @repetemusica
se c = "a" desvia @intpi
se c = "k" desvia @alt
se c = "m" desvia @msgcabpass
se c = "n" desvia @msgcop
se c = "b" desvia @infcop
se c = "c" desvia @contatatorre
se c = "t" desvia @inftempoabordo
se c = "h" desvia @malt
se c = "d" desvia @local2
se c = "f" desvia @vel
se c = "g" desvia @mvel
se c = "z" desvia @comb
se c = "#27" desvia @cancelar
desvia @painel

* Informa tempo a bordo:

@inftempoabordo
escreve ""$horas":"$minutos""
desvia @painel

* Sistema de curvas

* Curva para  direita

@cdir
se $left > 0
subtrai $left $velocidade
se $left < 0 seja $left 0
desvia @painel
seno
soma $right $velocidade
desvia @painel

* Controla Panning
          
@panningesquerda
mci $pleft "status fundo left volume"
mci $pright "status fundo right volume"
se $left > 0 seja $panning "Setaudio fundo left volume to "
se $left > 0 subtrai $pright $left
se $left > 0 concatena $panning $pright
se $left > 0 mci m $panning
retorna

@panningdireita
mci $pleft "status fundo left volume"
mci $pright "status fundo right volume"
se $right > 0 seja $panning "Setaudio fundo right volume to "
se $right > 0 subtrai $pleft $right
se $right > 0 concatena $panning $pleft
se $right > 0 mci m $panning
retorna

* Curva para  esquerda

@cesq
se $right > 0
subtrai $right $velocidade
se $right < 0 seja $right 0
desvia @painel
seno
soma $left $velocidade
desvia @painel

* Radar meteorolgico da Aeronave

@radarmet
se $chuva = 1
escreve "Chuva forte com troves"
desvia @painel
seno
se $chuva = 0
escreve "Cu aberto com poucas nvens"
desvia @painel

@hora
seja $hora hora
copia $hora1 $hora 1 2
seja $horario $hora1
concatena $horario " horas e "
copia $min $hora 4 5
concatena $horario $min
concatena $horario " minutos"
fala $horario
seja $horario ""
retorna

* Cancelar voo

@cancelar
imagem
tela limpa
mci m "stop fundo"
mci m "stop musica"
mci m "stop sons\aeronave\decol.mp3"
mci m "stop Sons\aeronave\decol.mp3"
mci m "stop estol"
mci m "stop estolii"
mci m "stop estol2"
mci m "stop Sons\Ambientes\thunder1.mp3"
mci m "stop chuva"
menu cria 3 5 50 5
menu adiciona "Voltar ao voo"
menu adiciona "Cancelar voo"
menu executa n $letra t
menu termina
se $letra = "#27"
mci m "play fundo repeat"
mci m "play musica"
se $emestol = 1 mci m "play estol repeat"
se $emestol = 1 mci m "play estolii"
se $emestol = 1 mci m "play estol2"
se $chuva = 1 mci m "play chuva"
desvia @painel
seno
se n = 1
mci m "play fundo repeat"
mci m "play musica"
se $emestol = 1 mci m "play estol repeat"
se $emestol = 1 mci m "play estolii"
se $emestol = 1 mci m "play estol2"
se $chuva = 1 mci m "play chuva"
desvia @painel
seno
se n = 2
desvia @cancelarvoo

* Cancela o voo

@cancelarvoo
tela limpa
escreve "Tem certeza de que deseja cancelar o voo "$voo""
escreve "com "$passageiros" passageiros, com destino em "d"?"
l mudo $cancelar &
se $cancelar = "#27" desvia @cancelar
se $cancelar = "n" desvia @cancelar
se $cancelar = "s" desvia @cancelarvoo2
desvia @cancelarvoo

@cancelarvoo2
tela limpa
seja l 0
seja $velocidade 269
seja $subiu 0
seja $alt 0
seja $fezcontato 0
seja $fezescala 0
se $online = 1 chama @avisacancelamento
escreve #1 ""
escreve #1 "Vo "$voo" cancelado"
fecha #1
desvia @main

* Avisa tripulao e passageiros do cancelamento do voo

@avisacancelamento
se $3 = 1 escreve #3 "[FS]cancelado"
se $3 = 2 escreve #3 "[FS]cancelado"
se $4 = 1 escreve #4 "[FS]cancelado"
se $5 = 1 escreve #5 "[FS]cancelado"
se $6 = 1 escreve #6 "[FS]cancelado"
se $7 = 1 escreve #7 "[FS]cancelado"
se $8 = 1 escreve #8 "[FS]cancelado"
se $9 = 1 escreve #9 "[FS]cancelado"
retorna

* Libera ou tira controle da aeronave do copiloto

@cabcop
se $online = 0 desvia @painel
se $copcontrolando = 0
seja $copcontrolando 1
escreve #3 "[FS]controle1"
desvia @painel
seno
se $copcontrolando = 1
seja $copcontrolando 0
escreve #3 "[FS]controle0"
desvia @painel

* Informa o nome do copiloto na cabine, se presente

@infcop
se $online = 0 desvia @painel
se $3 = 2 escreve "Copiloto: "$nome3""
se $3 < 2 escreve "No h copiloto neste voo."

* Envia uma mensagem da cabine para todos os passageiros

@msgcabpass
*se $online = 0  desvia @painel
fala "Fale a mensagem. Para finalizar, tecle ESC."
chama @gravasom

@msgcabpass2
l o &
se o = "#27" chama @fechasom
se o = "#27" desvia @enviasom
desvia @msgcabpass2 

* Envia mensagem de som para todos

@enviasom
abre #2 "!MSGAENVIAR.mp3"
se $3 = 1 escreve #3 "+AUDIO"
se $4 = 1 escreve #4 "+AUDIO"
se $5 = 1 escreve #5 "+AUDIO"
se $6 = 1 escreve #6 "+AUDIO"
se $7 = 1 escreve #7 "+AUDIO"
se $8 = 1 escreve #8 "+AUDIO"
se $9 = 1 escreve #9 "+AUDIO"

@enviasom2
l #2 $linha
checa $fimarq
se $fimarq <> 0 desvia @enviasom3
se $3 = 1 escreve #3 $linha
se $4 = 1 escreve #4 $linha
se $5 = 1 escreve #5 $linha
se $6 = 1 escreve #6 $linha
se $7 = 1 escreve #7 $linha
se $8 = 1 escreve #8 $linha
se $9 = 1 escreve #9 $linha
desvia @enviasom2

@enviasom3
fecha #2
remove "!MSG.mp3" &
remove "!MSGAENVIAR.mp3" &
se $3 = 1 escreve #3 "-AUDIO"
se $4 = 1 escreve #4 "-AUDIO"
se $5 = 1 escreve #5 "-AUDIO"
se $6 = 1 escreve #6 "-AUDIO"
se $7 = 1 escreve #7 "-AUDIO"
se $8 = 1 escreve #8 "-AUDIO"
se $9 = 1 escreve #9 "-AUDIO"
fala "Mensagem enviada com sucesso."
desvia @painel

* Comunicao entre piloto e copiloto

@msgcop
se $online = 0  desvia @painel
escreve "Escreva sua mensagem: "&
L $mensagem
se $3 = 2 escreve #3 "[MSG] Comandante "$nome" disse: "$mensagem""
se $3 < 2 escreve "No h copiloto neste voo."
seja $data data
seja $hora hora
se $3 = 2 escreve #1 ""$data" "$hora" GMT   Mensagem na cabine "$mensagem""
desvia @painel

* Se estiver online, lista passageiros

@listapass
se $online = 0
desvia @painel
seno
tela limpa
escreve ""
escreve "Lista de passageiros a bordo: "
escreve ""
se $3 = 1 escreve "Passageiro "$nome3" sentado no assento "$ass3""
se $4 = 1 escreve "Passageiro "$nome4" sentado no assento "$ass4""
se $5 = 1 escreve "Passageiro "$nome5" sentado no assento "$ass5""
se $6 = 1 escreve "Passageiro "$nome6" sentado no assento "$ass6""
se $7 = 1 escreve "Passageiro "$nome7" sentado no assento "$ass7""
se $8 = 1 escreve "Passageiro "$nome8" sentado no assento "$ass8""
se $9 = 1 escreve "Passageiro "$nome9" sentado no assento "$ass9""
desvia @painel

* Direes da aeronave no piloto automtico

@norte
se $pilotoautomatico = 0 desvia @painel
se $direcao = "w"
escreve "Direo do voo no piloto automtico j  norte"
desvia @painel
seno
seja $direcao "w"
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT  Controle   Direo do voo alterada para norte"
escreve "Direo do voo no piloto automtico alterada para norte"
desvia @painel

@sul
se $pilotoautomatico = 0 desvia @painel
se $direcao = "s"
seja $data data
seja $hora hora
escreve "Direo do voo no piloto automtico j  sul"
desvia @painel
seno
seja $direcao "s"
escreve "Direo do voo no piloto automtico alterada para sul"
desvia @painel

@dir
se $pilotoautomatico = 0 desvia @painel
se $direcao = "w" escreve "Direo da aeronave no piloto automtico: Norte"
se $direcao = "s" escreve "Direo da aeronave no piloto automtico: Sul"
desvia @painel

* Queda do avio

@queda
cor 4
escreve "ALERTA CRTICO" &
cor 15
escreve " Aeronave sem combustvel em queda!"

@queda2
* Fica derrubando o avio verticalmente e aumentando a velocidade devido
* a gravidade
espera 1
subtrai $alt 2000
soma $velocidade 22
se $direcao = "w" soma l $velocidade
se $direcao = "s" subtrai l $velocidade
se $alt < 0 desvia @caiu
observa teclado t 
se t <> 0 desvia @infoqueda
desvia @queda2

* Informaes sobre uma queda

@infoqueda
cor 4
toca "sons\error.wav"
escreve "Aeronave incontrolvel! "
escreve "Altura "$alt" ps e velocidade "$velocidade" m/s"
desvia @queda2

* Queda do voo (Pilotos)

@caiu
seja $alt 0
chama @parafundo
chama @avisaqueda
mci m "stop Sons\Aeronave\decol.mp3"
mci m "Stop sons\aeronave\decol.mp3"
mci m "stop musica"
mci m "stop estol"
mci m "stop estol2"
mci m "stop sounds\aeronave\decol.mp3"
mci m "stop estolii"
mci m "stop chuva"
chama @local
se $local *=* "Lagoa dos"
toca "Sons\Aeronave\fall_in_water.wav" &
espera 1
mci m "play Sons\Ambientes\patos.wav"
espera 17
desvia @falhou
seno  
se $local *=* "Oceano"
toca "Sons\Aeronave\fall_in_water.wav" &
espera 17
desvia @falhou
seno
toca "Sons\Aeronave\queda.wav" &
espera 14
desvia @falhou
      
* Queda do voo (Passageiros)

@caiupass
chama @parafundo
mci m "stop musica"
se w = "[FS]quedaagualagoa"
toca "sons\aeronave\fall_in_water.wav"
espera 1
toca "sons\ambientes\patos.wav"
espera 17
desvia @main
seno
se w = "[FS]quedaagua"
toca "sons\aeronave\fall_in_water.wav"
espera 24
desvia @main
seno
toca "sons\aeronave\queda.wav"
espera 17

* Avio pousado inadequadamente (passageiros)

@pfapass
chama @parafundo
chama @avisaquedafora
mci m "stop musica"
toca "sons\aeronave\queda.wav" &
espera 17
escreve "O voo "$voo" pousou fora do seu destino ("d")."
escreve "A aeronave "$aeronave" foi destruida."
desvia @main

* Gera informaes sobre uma queda

@falhou
imagem
tela limpa
cor 4
escreve ""
escreve "Informaes sobre a queda"
escreve ""
escreve #1 ""
escreve #1 "Vo "$voo" finalizado"
escreve #1 "---------------------"
escreve #1 ""
escreve #1 "Velocidade final: "$velocidade" m/s"
escreve #1 "Local da queda: "l" metros ("$local")"
escreve #1 "Nmero de passageiros a bordo: "$passageiros""
cor 15
escreve "Velocidade final: "$velocidade" m/s"
chama @local
escreve "Local da queda: "l" metros ("$local")"
escreve "Nmero de passageiros a bordo: "$passageiros"
escreve #1 "--------------------------------------------"
fecha #1
tela limpa
desvia @main

* Mostra combustvel atual da Aeronave:

@comb
escreve "Combustvel: "$combustivel" litros"
desvia @painel

* Localizao da Aeronave:

@local2
chama @local
escreve "Localizao: "$left"-"l"-"$right" ("$local")"
desvia @painel

@local

* Caso esteja chovendo, impedir "visualizao" de locais

se $chuva = 1 seja $local "Desconhecido"
se $chovendo = 1 retorna

substitui l "#" ""

* Verifica a quantidade de nmeros na varivel de localizao.
* Se o valor for 2 ou 3, equivale  rea doAeroporto Internacional
* Flight Simulator, que tem 4000 metros. Nesta rea, o avio
* pode ter percorrido 50 metros, 100 metros, etc. Por este
* motivo, os valores 2 e 3 equivalem aos dois nmeros que compe
* o nmero 50 e os trs do nmero 100. O restante  verificado.
* Se o valor for 4, copia-se o primeiro nmero, pois o Aeroporto
* Internacional tem 4000 metros.

seja t tamanho l

se t = 2
seja $local "Aeroporto Internacional de Pelotas"
retorna
seno
se t = 3
seja $local "Aeroporto Internacional de Pelotas"
retorna
seno
se t = 4
desvia @4num
seno
se t = 5
copia $tam l 1 2
seja y "("
concatena y $left
concatena y "-"
concatena y $tam
concatena y "-"
concatena y $right
concatena y ")"
desvia @5num
seno  
se t = 6
copia $tam l 1 3
seja y "("
concatena y $left
concatena y "-"
concatena y $tam
concatena y "-"
concatena y $right
concatena y ")"
desvia @6num
seno
se t = 7
copia $tam l 1 4
seja y "("
concatena y $left
concatena y "-"
concatena y $tam
concatena y "-"
concatena y $right
concatena y ")"
desvia @7num

* Se o valor de T for 4, copia o primeiro nmero para verificar
* se ainda est no Aeroporto Internacional Flight Simulator.

@4num
se y =* "(133-1"
seja $local "Pista 01 do Aeroporto Internacional Flight Simulator"
retorna
seno
se y =* "(127-3"
seja $local "Pista 02 do Aeroporto Internacional Flight Simulator"
retorna
seno
se l =* "1"
seja $local "Aeroporto Internacional Flight Simulator""
retorna
seno
se l =* "2"
seja $local "Aeroporto Internacional Flight Simulator""
retorna
seno
se l =* "3"
seja $local "Aeroporto Internacional Flight Simulator""
retorna
seno
se l =* "4"
seja $local "Prximo ao Aeroporto Internacional Flight Simulator"
retorna
seno
se l =* "5"
seja $local "Prximo ao Aeroporto Internacional Flight Simulator"
desvia @Painel
seno
se l =* "6"
seja $local "Prximo ao Aeroporto Internacional Flight Simulator"
retorna
seno
seja $local "Desconhecido"
retorna

* Se o valor de T for 5, copia-se os dois primeiros nmeros.
* Neste caso, pode ser 50 a 54, que  o tamanho do Aeroporto
* Internacional de Porto Alegre.

@5num
se l =* "48"
seja $local "Lagoa dos Patos (Pelotas/RS)"
retorna
seno
se l =* "49"
seja $local "Ilha da Saragonha (Pelotas/RS)"
retorna
seno
se y =* "(155-51"
seja $local "Pista 01 do Aeroporto Internacional de Pelotas"
retorna
seno
se y =* "(111-53"
seja $local "Pista 02 do Aeroporto Internacional de Pelotas"
retorna
seno
se y =* "(433-54"
seja $local "Pista 03 do Aeroporto Internacional de Pelotas"
retorna
seno
se l =* "51"
seja $local "Aeroporto Internacional de Pelotas"
retorna
seno
se l =* "52"
seja $local "Aeroporto Internacional de Pelotas"
retorna
seno
se l =* "53"
seja $local "Aeroporto Internacional de Pelotas"
retorna
seno
se l =* "54"
seja $local "Aeroporto Internacional de Pelotas"
retorna
seno
se l =* "55"
seja $local "Prximo ao Aeroporto Internacional de Pelotas"
retorna
seno
se l =* "56"
seja $local "Prximo ao Aeroporto Internacional de Porto Alegre"
retorna
seno
se l =* "57"
seja $local "Prximo ao Aeroporto Internacional de Porto Alegre"
retorna
seno
se l =* "58"
seja $local "Prximo ao Aeroporto Internacional de Porto Alegre"
retorna
seno
seja $local "Desconhecido"
retorna

* Ou tambm pode ser de 6 nmeros, mais de 100000 metros (100km)

@6num
se y =* "(136-153"
seja $local "Pista 01 do Aeroporto Internacional de Porto Alegre"
retorna
seno
se y =* "155-149)"
seja $local "Pista 02 do Aeroporto Internacional de Porto Alegre"
retorna
seno
se y =* "(233-151"
seja $local "Pista 03 do Aeroporto Internacional de Porto Alegre"
retorna
seno
se l =* "152"
seja $local "Aeroporto Internacional de Porto Alegre"
retorna
seno
se l =* "153"
seja $local "Aeroporto Internacional de Porto Alegre"
retorna
seno
se l =* "154"
seja $local "Aeroporto Internacional de Porto Alegre"
retorna
seno
se l =* "155"
seja $local "Aeroporto Internacional de Porto Alegre"
retorna
seno
se l =* "156"
seja $local "Prximo ao Aeroporto Internacional de Porto Alegre"
retorna
seno
se y *= "357-222)"
seja $local "Pista 01 do Aeroporto Internacional de Guarulhos"
retorna
seno
se y *= "(227-358"
seja $local "Pista 02 do Aeroporto Internacional de Guarulhos"
retorna
seno
se y *= "(242-359"
seja $local "Pista 03 do Aeroporto Internacional de Guarulhos"
retorna
seno
se l =* "356"
seja $local "Aeroporto Internacional de Guarulhos"
retorna
seno
se l =* "357"
seja $local "Aeroporto Internacional de Guarulhos"
retorna
seno
se l =* "358"
seja $local "Aeroporto Internacional de Guarulhos"
retorna
seno
se l =* "359"
seja $local "Aeroporto Internacional de Guarulhos"
retorna
seno
se l =* "360"
seja $local "Prximo ao Aeroporto Internacional de Guarulhos"
retorna
seno
se l =* "361"
seja $local "Prximo ao Aeroporto Internacional de Guarulhos"
retorna
seno
se l =* "362"
seja $local "Prximo ao Aeroporto Internacional de Guarulhos"
retorna
seno
se y *= "581-135)"
seja $local "Pista 01 do Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se y =* "(111-583"
seja $local "Pista 02 do Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se y *= "585-133)"
seja $local "Pista 03 do Internacional do Rio de Janeiro Galeo"
retorna
seno
se l =* "582"
seja $local "Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se l =* "583"
seja $local "Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se l =* "584"
seja $local "Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se l =* "586"
seja $local "Prximo ao Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se l =* "587"
seja $local "Prximo ao Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se l =* "588"
seja $local "Prximo ao Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se l =* "589"
seja $local "Prximo ao Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se l =* "590"
seja $local "Prximo ao Aeroporto Internacional do Rio de Janeiro Galeo"
retorna
seno
se l =* "871"
seja $local "Oceano ndico"
retorna
seno
se l =* "993"
seja $local "Oceano Atlntico"
retorna
seno
seja $local "Desconhecido"
retorna

* Mais de 1.000.000 metros

@7num
se y =* "(222-1434"
seja $local "Pista 01 do Aeroporto Internacional Charles de Gaulle"
retorna
seno
se y *= "1436-201)"
seja $local "Pista 02 do Aeroporto Internacional Charles de Gaulle"
retorna
seno
se y =* "(190-1438"
seja $local "Pista 03 do Internacional Charles de Gaulle"
retorna
seno
se l =* "1433"
seja $local "Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1434"
seja $local "Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1435"
seja $local "Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1436"
seja $local "Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1437"
seja $local "Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1438"
seja $local "Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1439"
seja $local "Prximo ao Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1440"
seja $local "Prximo ao Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1441"
seja $local "Prximo ao Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1442"
seja $local "Prximo ao Aeroporto Internacional Charles de Gaulle"
retorna
seno
se l =* "1443"
seja $local "Prximo ao Aeroporto Internacional Charles de Gaulle"
retorna
seno
seja $local "Desconhecido"
retorna

* Controle dos Flaps da aeronave

@ctrlflaps
se $flaps = 0
seja $flaps 1
escreve "Posio dos Flaps alterada para cima"
desvia @painel
seno
se $flaps = 1
seja $flaps 0
escreve "Posio dos Flaps alterada para baixo"
desvia @painel
seno
desvia @painel

* Avisa piloto de que o copiloto est no controle da Aeronave

@copcontrolandomsg
escreve "Copiloto "$nome3" est no controle da Aeronave."
escreve "Para controlar a aeronave, avise ao copiloto a posse de seu
escreve "controle e tecle O."
desvia @painel

* Mudana de velocidade:

@mvel
se $copcontrolando = 1 desvia @copcontrolandomsg
escreve "Informe a velocidade mdia em m/s: " &
l $2v
se $2v <= 0
escreve "Velocidade no pode ser igual a 0."
desvia @mvel
seno
se $2v > 269
escreve "Velocidade no pode ultrapassar 269m/s."
desvia @painel
seno
se $2v < $velocidade mci m "play Sons\Aeronave\vel_down.wav"
se $2v > $velocidade mci m "play Sons\Aeronave\vel_up.wav"
seja $velocidade $2v
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT  Controle   Velocidade da aeronave alterada para "v" m/s pelo piloto"
desvia @painel

* Mudana de altitude

@malt
se $emestol = 1 desvia @painel
escreve "Informe a altura em ps da aeronave (mnimo de"
escreve "4 a 43500 ps de altura."
l $2alt
se $2alt < 4
escreve "Altura no pode ser menor que 4 ps de altura."
desvia @malt
seno
se $2alt > 43500
escreve "Altura no pode exceder 43500 ps de altura."
desvia @painel
seno
seja $mudandodealt 1
seja $hora hora
seja $data data
escreve #1 ""$data" "$hora"  Controle   Altura em ps da aeronave alterada pelo piloto"
desvia @painel

* Realiza alterao da altura da aeronave

@mudandoalt
se $emestol = 1 retorna
se $alt > $2alt subtrai $alt 500
se $alt < $2alt soma $alt 500
escreve ""$alt" ps"
toca "Sons\Aeronave\vel_up.wav" &
se $alt = $2alt seja $mudandodealt 0
retorna

* Liga/desliga piloto automtico

@intpi
se $pilotoautomatico = 0
seja $pilotoautomatico 1
seja $hora hora
seja $data data
escreve #1 ""$data" "$hora" GMT  Controle   Piloto automtico ligado"
toca "Sons\Aeronave\piloto_automatico.wav" &
escreve "Piloto Automtico ligado."
desvia @painel
seno
se $pilotoautomatico = 1
seja $pilotoautomatico 0
escreve #1 ""$data" "$hora" GMT  Controle   Piloto automtico desligado"
toca "Sons\Aeronave\piloto_automatico.wav" &
escreve "Piloto Automtico desligado."
desvia @painel

* Mostra velocidade da Aeronave

@vel
escreve "Velocidade da Aeronave: "$velocidade" m/s"
desvia @Painel

* Mostra altura da Aeronave

@alt
escreve "Altura em ps: "$alt" ps"
desvia @painel

* Controle manual da Aeronave:

@kmm
se $pilotoautomatico = 1
escreve $pilig
desvia @painel
seno
seja r rand 5
subtrai $velocidade r
seja r rand 9
soma $velocidade r
soma l $velocidade
seja v $velocidade

*
* Se muito alto, consome pouco combustvel.
* Aeronave voa mais rapidamente e consome menos combustvel em
* altitude alta.
*
* OBS: v = Varivel descartvel, aproveitando para diminuir
* combustvel baseado na velocidade
*

se l < 0 desvia @ultrapassou
se $alt >= 40000 divide v 3
se $alt >= 30000 divide v 3
se $alt <= 10000 divide v 2
subtrai $combustivel v
seja $data data
seja $hora hora
chama @local
escreve #1 ""$data" "$hora" GMT  Controle  Aeronave sobrevoando "$local" ("$left"-"l"-"$right") para o norte manualmente a "$velocidade" m/s  "$alt"" &
escreve #1 "Flaps = " &
se $flaps = 1 escreve #1 "cima"
se $flaps = 0 escreve #1 "baixo"
desvia @painel

* Controle manual (para sul)

@kmmb
se $pilotoautomatico = 1
escreve $pilig
desvia @painel
seno
seja r rand 4
subtrai $velocidade r
seja r rand 4
soma $velocidade r
subtrai l $velocidade
seja v $velocidade
se l < 0 desvia @ultrapassou
se $alt >= 40000 divide v 3
se $alt >= 30000 divide v 3
se $alt <= 10000 divide v 2
escreve #1 ""$data" "$hora" GMT  Controle  Aeronave sobrevoando "$local" para o sul manualmente a "$velocidade" m/s  "$alt" ps, flaps = "&
se $flaps = 0 escreve #1 "baixo"
se $flaps = 1 escreve #1 "cima"
subtrai $combustivel v
seja $data data
seja $hora hora
chama @local
escreve #1 ""$data" "$hora" GMT  Controle  Aeronave sobrevoando "$local" para o sul manualmente a "$velocidade" m/s  "$alt" ps"
desvia @painel

* Controle do Piloto Automtico:

@km
se $subiu = 0 desvia @painel
seja r rand 3
subtrai $velocidade r
seja r rand 3
soma $velocidade r
seja v $velocidade
se $velocidade > 269 desvia @km
se $direcao = "w" soma l $velocidade
se $direcao = "s" subtrai l $velocidade
se l < 0 desvia @ultrapassou
se $alt >= 40000 divide v 3
se $alt >= 30000 divide v 3
se $alt <= 10000 divide v 2
subtrai $combustivel $velocidade

* Controla altitude para manter a aeronave reta, com pequenas variaes
* no ar (alguns pulos pequenos)

randomiza
seja a rand 3
subtrai $alt a
randomiza
seja a rand 3
soma $alt a
seja $data data
seja $hora hora
se $online = 0
se $direcao = "w" escreve #1 ""$data" "$hora" GMT  Controle  Aeronave sobrevoando "$local" para o norte no piloto automtico a "$velocidade" m/s  "$alt" ps"
se $direcao = "s" escreve #1 ""$data" "$hora" GMT  Controle  Aeronave sobrevoando "$local" para o sul no piloto automtico a "$velocidade" m/s  "$alt" ps"
espera 1
retorna

* Sistema de avisos da aeronave:

@wcomb
se $wcomb = 0
seja $wcomb 1
cor 4
toca "sons\error.wav" &
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT        Alerta     Pouco combustvel ("$combustivel" litros)"
escreve "ALERTA "&
cor 15
escreve "Pouco combustvel"
retorna
seno
retorna

@wmtesq
se $wmtesq = 0
seja $wmtesq 1
cor 4
toca "sons\error.wav" &
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT       Alerta      Motor esquerdo desligado"
escreve "ALERTA "&
cor 15
escreve "Motor esquerdo desligado"
retorna
seno
retorna

@wmtdir
se $wmtdir = 0
seja $wmtdir 1
cor 4
toca "sons\error.wav" &
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT      Alerta       Motor direito desligado"
escreve "ALERTA "&
cor 15
escreve "Motor direito desligado"
retorna
seno
retorna

@waltit
se $subiu = 0 retorna 
cor 4
escreve "ALERTA "&
cor 15
escreve "Aeronave voando a baixa altitude"
retorna

@wveloc
se $flaps = 1 retorna
cor 4
escreve "ALERTA "&
cor 15
escreve "Aeronave em baixa velocidade, perda de sustentao"
retorna

* Inicia pouso

@pouso
tela limpa
escreve ""
escreve "Iniciando procedimento de pouso..."
escreve ""
chama @local
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT       Controle      Aeronave sendo pousada em "$local""
toca "sons\aeronave\vel_down.wav" &
escreve "Pousando em "$local""
escreve ""
desvia @pousando
      
* Realiza o pouso

@pousando
escreve "Iniciando descida a "$alt" ps..."
enquanto no $alt <= 0
escreve ""
escreve ""$alt" ps"
subtrai $alt 2000
fim enquanto
seja $subiu 0
escreve ""
chama @parafundo
mci m "stop musica"
mci m "stop chuva"
chama @local
se $local *=* d
chama @pousounapista
chama @pousounapistadesignada
escreve ""
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT     Controle     Aeronave pousou em seu destino ("d")"
escreve #1 ""
escreve #1 "Vo "$voo" finalizado com xito"
escreve #1 "----------------------------"
fecha #1
se $3 = 1 escreve #3 "[FS]pousado"
se $4 = 1 escreve #4 "[FS]pousado"
se $5 = 1 escreve #5 "[FS]pousado"
se $6 = 1 escreve #6 "[FS]pousado"
se $7 = 1 escreve #7 "[FS]pousado"
se $8 = 1 escreve #8 "[FS]pousado"
se $9 = 1 escreve #9 "[FS]pousado"
abre #2 "Flight Simulator.cfg"
L #2 l
L #2 l
l #2 $intro
L #2 l
l #2 l
l #2 $contpass
l #2 $tempo
substitui $contpass "passageiros=" ""
substitui $tempo "tempo=" ""
substitui $intro "intro=" ""
soma $contpass $passageiros
soma $tempo $tempoabordo
fecha #2
remove "Flight Simulator.cfg" &
abre #2 "Flight Simulator.cfg" &
escreve #2 "[Flight Simulator]"
escreve #2 "comandante="$nome""
escreve #2 "intro="$intro""
escreve #2 ""
escreve #2 "[contadores]"
escreve #2 "passageiros="$contpass""
escreve #2 "tempo="$tempo""
fecha #2
seja $passageiros 0
imagem
toca "sons\FS\end_applause.wav"
escreve "O voo "$voo" pousou em seu destino: "d""
tela limpa
desvia @main
seno
desvia @errado

* Aeronave pousou na pista do destino?

@pousounapista
se $local *=* "Pista"
retorna
seno
desvia @caiu

* Pouso fora do destino
*
* Algo deu errado no pouso?
*
* Se o local no for o destino da misso, talvez seja um aeroporto.
* Nesse caso,  feito um pouso no aeroporto em que foi pousado.
*
* Escalas
*
* Se o combustvel para o destino no for suficiente,
* a aeronave ser abastecida.
*
* Se no for um aeroporto ou escala, a aeronave cair fora do aeroporto.

@errado
se $emestol = 1
* Piloto tentou pousar aeronave no nivelada. Em resultado, a aeronave
* inclinada para esquerda ou direita bateu no solo e explodiu.
*
* Registrando queda devido a Estol no gravador de dados...
*
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT    Mensagem     Aeronave em Estol, tentativa de pouso falhou."
desvia @caiu
seno
chama @local
se $local *=* $escala
chama @pousounapista
se $fezescala = 1 desvia @naopodeescala
mci m "stop fundo"
mci m "play airport repeat"
se $3 = 1 escreve #3 "[FS]escalando"
se $4 = 1 escreve #4 "[FS]escalando"
se $5 = 1 escreve #5 "[FS]escalando"
se $6 = 1 escreve #6 "[FS]escalando"
se $7 = 1 escreve #7 "[FS]escalando"
se $8 = 1 escreve #8 "[FS]escalando"
se $9 = 1 escreve #9 "[FS]escalando"
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora"  Mensagem   Vo "$voo" fazendo sua escala no "$escala""
desvia @escala
seno 
se $local *=* "Aeroporto"
chama @pousounapista
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT  Mensagem   Vo "$voo" fez um pouso forado no "$local""
desvia @pousoforcado
seno
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora"  Mensagem   Vo "$voo" pousou fora do aeroporto e caiu"
desvia @pfa

* Pouso forado em um aeroporto fora da rota

@pousoforcado
tela limpa
mci m "play sons\ambientes\airport.mp3 repeat"
seja $subiu 0
escreve "O voo "$voo" fez um pouso no "$local"."
escreve ""
escreve "Seu destino : "z" ("d")"
escreve ""
desvia @pousoforcado2
       
@checacomb
se m < l desvia @combmenos
se m > l desvia @combnormal

@abast
escreve "O combustvel da aeronave para chegar em seu destino "
escreve "("d")  insuficiente."
escreve ""
escreve "So necessrios "$combprec" litros para viajar ao destino, e a"
escreve "aeronave possui somente "$combustivel" litros de combustvel."
escreve ""
escreve "Abastecendo aeronave..."
escreve ""
seja $combustivel 0
soma $combustivel $combprec
soma $combustivel 8000
escreve "Aeronave abastecida."
escreve ""
escreve "Combustvel atual: "$combustivel" litros ("$combprec" + 8000
escreve "litros de reserva)"
tela limpa
desvia @pousoforcado2
      
@combmenos
seja j l
seja k $destino
enquanto no k = l
subtrai k 1
soma $combprec 1
fim enquanto

se $combustivel < $combprec
desvia @abast
seno
desvia @pousoforcado2
       
@combnormal
seja j l
seja k m
enquanto no k = l
soma j 1
soma $combprec 1
fim enquanto

se $combustivel < $combprec
desvia @abast
seno
desvia @pousoforcado2
       
@pousoforcado2
tela limpa
escreve ""
escreve "A aeronave do voo "$voo" com "$passageiros" passageiros est"
escreve "pronta para voar."
escreve ""
escreve "Confirmando informaes do voo: "
escreve ""
chama @info
escreve ""
escreve "Pressione qualquer tecla para iniciar o voo."
l mudo y &
espera 1
se $escala *=* $local chama @avisafimdaescala
escreve ""
tela limpa
escreve "Iniciando decolagem de "$local"..."
seja j 0
seja k 0
seja $combprec 0
seja $fezcontato 0
mci m "Open sons\aeronave\amb.wav alias fundo"
mci m "stop aeroporto"
mci m "play fundo repeat"
toca "sons\aeronave\decol.mp3" &
espera 25
tela limpa
mci m "play musica"
seja $fezcontato 0
desvia @painel

* Avisa passageiros sobre fim da escala

@avisafimdaescala
se $3 = 1 escreve #3 "decolar"
se $4 = 1 escreve #4 "decolar"
se $5 = 1 escreve #5 "decolar"
se $6 = 1 escreve #6 "decolar"
se $7 = 1 escreve #7 "decolar"
se $8 = 1 escreve #8 "decolar"
se $9 = 1 escreve #9 "decolar"
retorna

* Avisa passageiros sobre queda da aeronave

@avisaqueda
se $3 = 1 escreve #3 "[FS]queda"
se $4 = 1 escreve #4 "[FS]queda"
se $5 = 1 escreve #5 "[FS]queda"
se $6 = 1 escreve #6 "[FS]queda"
se $7 = 1 escreve #7 "[FS]queda"
se $8 = 1 escreve #8 "[FS]queda"
se $9 = 1 escreve #9 "[FS]queda"
retorna

@avisaquedafora
se $3 = 1 escreve #3 "[FS]quedafora"
se $4 = 1 escreve #4 "[FS]quedafora"
se $5 = 1 escreve #5 "[FS]quedafora"
se $6 = 1 escreve #6 "[FS]quedafora"
se $7 = 1 escreve #7 "[FS]quedafora"
se $8 = 1 escreve #8 "[FS]quedafora"
se $9 = 1 escreve #9 "[FS]quedafora"
retorna

* Pouso fora do aeroporto

@pfa
chama @parafundo
chama @avisaquedafora
mci m "stop musica"
mci m "stop chuva"
mci m "stop estol"
mci m "stop estolii"
mci m "stop estol2"
chama @local
se $local *=* "Lagoa"
toca "Sons\Aeronave\fall_in_water.wav" &
espera 10
toca "sons\aeronave\queda.wav"
desvia @pfa2
seno
se $local *=* "Oceano"
toca "Sons\Aeronave\queda.wav" &
espera 17
desvia @pfa2
seno
toca "Sons\Aeronave\queda.wav" &
espera 17
desvia @pfa2

@pfa2
escreve "O voo "$voo" pousou fora do seu destino ("d")"
escreve "e a aeronave ("$aeronave" foi destruida."
desvia @falhou

* Aeronave em Estol

@emestol
se $flaps = 1
seja $emestol 0
retorna
seno
cor 4
se $alt <= 0 desvia @caiu
se $alt > 0 subtrai $alt 2000
chama @somestol
se $aeronave *=* "Airbus" toca "Sons\Alarmes\Boeing\estol1.wav" &
se $aeronave *=* "Boeing" toca "Sons\Alarmes\Boeing\estol1.wav" &
escreve "ALERTA "&
cor 15
se $aeronave *=* "Douglas"
mci m "play Sons\Alarmes\Douglas\stall.wav"
fim se
escreve "Stall!"
retorna

* Controla som do Estol

@somestol
se $aeronave *=* "Boeing"
se $velocidade < 30 toca "Sons\Alarmes\Boeing\estol1.wav" &
mci m "play Sons\Alarmes\Boeing\Estol4.wav"
mci m "play Sons\Alarmes\Boeing\estol1.wav"
mci m "play Sons\Alarmes\Boeing\estol3.wav"
mci m "play Sons\Alarmes\Boeing\estol5.wav"
retorna
seno
se $aeronave *=* "Airbus"
mci m "Open Sons\Alarmes\Airbus\estol2.mp3 alias estol"
mci m "play estol repeat"
mci m "play Sons\Alarmes\Airbus\Estol5.wav"
retorna
seno
se $aeronave *=* "Douglas"
mci m "open Sons\Alarmes\Douglas\moving.mp3 alias estol"
mci m "play estol repeat"
mci m "play Sons\Alarmes\Douglas\beep.wav"
retorna

* Controla som do ambiente da aeronave

@parafundo
mci m "stop fundo"
retorna

* Informaes sobre um voo

@info
escreve "Nome do voo: "$voo""
escreve "Destino: "z" ("d")"
chama @local
escreve "Local atual: "l" ("$local")"
escreve "N de passageiros: "$passageiros""
escreve "N de tripulantes: "$tripulantes""
retorna

* Escala do voo

@escala
imagem ""
tela limpa
se $fezescala = 1 desvia @naopodeescala
escreve ""
mci m "stop musica"
mci m "play aeroporto repeat"
seja $subiu 0
escreve "O voo "$voo" est fazendo sua escala no "$escala"."
escreve ""
seja $fezescala 1
desvia @escala2

* J fez a escala

@naopodeescala
tela limpa
escreve ""
escreve "No  possvel pousar aqui: A escala do voo "$voo" j foi realizada."
desvia @painel

@escala2
tela limpa
escreve ""
escreve "Escala no "$escala""
escreve ""
desvia @escala3

@escala3
observa teclado t
se t <> 0 l $cmd &
se $cmd = "#13" desvia @pousoforcado2
se $cmd = "r"   desvia @checacombescala
se $cmd = "c"   desvia @maisembair2
se $cmd = "m"   desvia @
se $online = 1 desvia @escalapass
desvia @escala3

@escalapass
chama @descobremsg
se c = "[FS]desconec" desvia @desconecescala
desvia @escala3

@desconecescala
subtrai $passageiros 1
toca "Sons\FS\desembarcando.wav" &
se $mandou = "#3"
seja $3 0
fecha #3
seja $saiu $nome3
escreve "Passageiro "$saiu" saiu do voo"
chama @avisasaiu
desvia @escala3
seno
se $mandou = "#4"
seja $4 0
fecha #4
seja $saiu $nome4
escreve "Passageiro "$saiu" saiu do voo"
chama @avisasaiu
desvia @escala3
seno
se $mandou = "#5"
seja $5 0
fecha #5
seja $saiu $nome5
escreve "Passageiro "$saiu" saiu do voo"
chama @avisasaiu
desvia @escala3
seno
se $mandou = "#6"
seja $6 0
fecha #6
seja $saiu $nome6
escreve "Passageiro "$saiu" saiu do voo"
chama @avisasaiu
desvia @escala3
seno
se $mandou = "#7"
seja $7 0
fecha #7
seja $saiu $nome7
escreve "Passageiro "$saiu" saiu do voo"
chama @avisasaiu
desvia @escala3
seno
se $mandou = "#8"
seja $8 0
fecha #8
seja $saiu $nome8
escreve "Passageiro "$saiu" saiu do voo"
chama @avisasaiu
desvia @escala3
seno
se $mandou = "#8"
seja $8 0
fecha #8
seja $saiu $nome8
escreve "Passageiro "$saiu" saiu do voo"
chama @avisasaiu
desvia @escala3

* Avisa o restante dos passageiros sobre a sada de um passageiro
* no voo

@avisasaiu
se $3 = 1 escreve #3 "[SAIU] Passageiro "$saiu" saiu do voo"
se $4 = 1 escreve #4 "[SAIU] Passageiro "$saiu" saiu do voo"
se $5 = 1 escreve #5 "[SAIU] Passageiro "$saiu" saiu do voo"
se $6 = 1 escreve #6 "[SAIU] Passageiro "$saiu" saiu do voo"
se $7 = 1 escreve #7 "[SAIU] Passageiro "$saiu" saiu do voo"
se $8 = 1 escreve #8 "[SAIU] Passageiro "$saiu" saiu do voo"
se $9 = 1 escreve #9 "[SAIU] Passageiro "$saiu" saiu do voo"
desvia @escala3

desvia @escala3

* Checa combustvel da aeronave na escala

@checacombescala
escreve "Verificando condies da aeronave..."
escreve ""
chama @checacomb
tela limpa
desvia @escala2

* Verifica configuraes

@veconfig
busca a "*.cfg"
se a = ""
escreve ""
escreve "Configuraes"
escreve ""
escreve "Informe o nome do comandante dos voos: "&
L $nome
escreve ""
abre #2 "Flight Simulator.cfg" &
escreve #2 "[Flight Simulator]"
escreve #2 "comandante="$nome""
escreve #2 "intro=1"
escreve #2 ""
escreve #2 "[contadores]"
escreve #2 "passageiros=0"
escreve #2 "tempo=0"
escreve "OK"
fecha #2
desvia @opc
seno
abre #2 "Flight Simulator.cfg"
l #2 l
l #2 $nome
l #2 $intro
substitui $intro "intro=" ""
l #2 l
l #2 l
l #2 $contpass
l #2 $tempo
substitui $contpass "passageiros=" ""
substitui $tempo "tempo=" ""
substitui $nome "comandante=" ""
fecha #2
desvia @opc

* Aeronave ultrapassou limite do comeo do mapa

@ultrapassou
seja $direcao "w"
cor 4
seja $data data
seja $hora hora
escreve #1 ""$data" "$hora" GMT  Alerta     Piloto "$nome" ultrapassou limite do comeo do mapa, indo na direo contrria (sul). Direo alterada
escreve #1 "para norte."
seja l 0
escreve "ALERTA "&
cor 15
escreve "Aeronave ultrapassou limite do comeo do mapa (0) voando na
escreve "direo sul (contrria). A direo foi alterada para norte."
desvia @painel

*------------------------------------------------------------------

* Ouvir msica

@ouvirmusica
tela limpa
mci m "stop musica"
escreve ""
escreve "Ouvir msica"
escreve ""
escreve "Informe o nome do arquivo de udio: "&
l $audio
se $audio = ""
mci m "play musica"
escreve "Desistiu"
retorna
seno
fim se
mci m "close musica"
seja $comando "Open "
concatena $comando $aspas
concatena $comando $audio
concatena $comando $aspas
concatena $comando " alias musica"
mci m $comando
escreve "Deseja reproduzir o arquivo com repetio ao trmino?" &
L r &
escreve ""
escreve ""
se r = "n" mci m "play musica"
se r = "s" mci m "play musica repeat"
seja $data data
seja $hora hora
se $funcao = "piloto" escreve #1 ""$data" "$hora" GMT     Mensagem     Reproduzindo arquivo "$musica""
retorna

* Pausa msica

@pausamusica
mci m "status musica mode"
se m *=* "stopp" mci m "play musica"
se m *=* "playi" mci m "stop musica"
retorna

* Repete msica

@repetemusica
mci m "close musica"
mci m "play musica"
retorna

* Determina de onde foi enviada uma mensagem ao servidor

@descobremsg
observa #3 m
se m <> 0
l #3 c
seja $mandou "#3"
retorna
seno
observa #4 m
se m <> 0
l #4 c
seja $mandou "#4"
retorna
seno
observa #5 m
se m <> 0
l #5 c
seja $mandou "#5"
retorna
seno
observa #6 m
se m <> 0
l #6 c
seja $mandou "#6"
retorna
seno
observa #7 m
se m <> 0
l #7 c
seja $mandou "#7"
retorna
seno
observa #8 m
se m <> 0
L #8 c
retorna
seno
observa #9 m
se m <> 0
l #9 c
seja $mandou "#9"
retorna
seno
retorna

* Define ttulo padro

@titulopadrao
Ttulo "Flight Simulator"
retorna

* Sintetiza dados numricos

@falanumeros
se $numf = 0 toca "Sons\FS\0.wav" &
se $numf = 1 toca "Sons\FS\1.wav" &
se $numf = 2 toca "Sons\FS\2.wav" &
se $numf = 3 toca "Sons\FS\3.wav" &
se $numf = 4 toca "Sons\FS\4.wav" &
se $numf = 5 toca "Sons\FS\5.wav" &
se $numf = 6 toca "Sons\FS\6.wav" &
se $numf = 7 toca "Sons\FS\7.wav" &
se $numf = 8 toca "Sons\FS\8.wav" &
se $numf = 9 toca "Sons\FS\9.wav" &
espera 1
retorna

* Faz contato com a Torre de Controle areo

@contatatorre
se $fezescala = 0 desvia @contatoescala
se l < $posiccontato
fala "Contato com o controle de trfego areo no necessrio."
desvia @painel
seno
se $fezcontato = 1
fala "Contato com Torre de controle foi realizado."
desvia @painel
seno
randomiza
Seja $pistadepouso rand 2
se $pistadepouso = 0 seja $pistadepouso 1
se $pistadepouso = 1 seja $pistadepouso 2
se $pistadepouso = 2 seja $pistadepouso 3
seja $fezcontato 1
fala "Ateno torre do "d": voo "
toca "Sons\FS\contact_fname.wav"
seja $count 1
seja $voo2 $voo
substitui $voo2 "FS" ""
seja t tamanho $voo2
enquanto no $count > t
copia $numf $voo2 $count $count
chama @falanumeros
soma $count 1
fim enquanto
seja $count 1
fala "Pedindo autorizao de pouso no "d"."
espera 4
toca "Sons\FS\contact_tower1.wav"
seja $pista 0
concatena $pista $pistadepouso
seja $pistadepouso $pista
seja t tamanho $pistadepouso
enquanto no $count > t
copia $numf $pistadepouso $count $count
chama @falanumeros
soma $count 1
fim enquanto
seja $count 1
toca "Sons\FS\contact_tower2.wav"
se d *=* "Porto Alegre" toca "Sons\Ambientes\aipa.wav"
se $chuva = 1
toca "Sons\FS\visible_warning.wav"
seja $count 1
enquanto no $count > t
copia $numf $pistadepouso $count $count
chama @falanumeros
soma $count 1
fim enquanto
seja $count 1
desvia @painel
seno
desvia @painel

* Trata contato em escala

@contatoescala
se l < $posiccontatoescala
fala "Contato com o controle de trfego areo no necessrio."
desvia @painel
seno
se $fezcontato = 1
fala "Contato com Torre de controle foi realizado."
desvia @painel
seno
randomiza
Seja $pistadepouso rand 2
se $pistadepouso = 0 seja $pistadepouso 1
se $pistadepouso = 1 seja $pistadepouso 2
se $pistadepouso = 2 seja $pistadepouso 3
seja $fezcontato 1
fala "Ateno torre do "$escala": voo "
toca "Sons\FS\contact_fname.wav" 
seja $count 1
seja $voo2 $voo
substitui $voo2 "FS" ""
seja t tamanho $voo2
enquanto no $count > t
copia $numf $voo2 $count $count
chama @falanumeros
soma $count 1
fim enquanto
seja $count 1
fala "Pedindo autorizao de pouso no "$escala"."
espera 4
toca "Sons\FS\contact_tower1.wav"
seja $pista 0
concatena $pista $pistadepouso
seja $pistadepouso $pista
seja t tamanho $pistadepouso
enquanto no $count > t
copia $numf $pistadepouso $count $count
chama @falanumeros
soma $count 1
fim enquanto
seja $count 1
toca "Sons\FS\contact_tower2.wav"
se $escala *=* "de Pelotas" toca "Sons\Ambientes\aip.wav"
se $chuva = 1 toca "Sons\FS\visible_warning.wav"
se $chuva = 1 enquanto no $count = t
se $chuva = 1 copia $numf $pistadepouso $count $count
se $chuva = 1 chama @falanumeros
se $chuva = 1 soma $count 1
se $chuva = 1 fim enquanto
seja $count 1
desvia @painel

* Verifica se aeronave pousou na pista designada pelo
* Controle de Trfego Areo           

@pousounapistadesignada
se $pistadepouso *=* d
retorna
seno
desvia @pousoforcado

* Grava uma mensagem de udio

@gravasom
MCI m "Open New Type WaveAudio Alias FSMSG buffer 5"
mci m "set FSMSG time format ms bitspersample 16 channels 2 samplespersec 44100"
MCI m "Record FSMSG"
retorna

* Encerra uma gravao

@fechasom
MCI m "Stop FSMSG"
MCI m "Stop CDAudio"
mci m "Save FSMSG !MSG.wav"
MCI m "Close CDAudio"
MCI m "Close FSMSG"
executa "lame -h !MSG.wav !MSG.mp3"
codarqbase64 "!MSG.mp3" "!MSGAENVIAR.mp3"
retorna
